/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 24 "../../usr.sbin/smtpd/parse.y"

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <limits.h>
#include <netdb.h>
#include <pwd.h>
#include <stdarg.h>
#include <resolv.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	size_t			 ungetpos;
	size_t			 ungetsize;
	u_char			*ungetbuf;
	int			 eof_reached;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 igetc(void);
int		 lgetc(int);
void		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct table		*table = NULL;
struct mta_limits	*limits;
static struct pki	*pki;
static struct ca	*sca;

struct dispatcher	*dispatcher;
struct rule		*rule;
struct filter_proc	*processor;
struct filter_config	*filter_config;
static uint32_t		 last_dynchain_id = 1;

enum listen_options {
	LO_FAMILY	= 0x000001,
	LO_PORT		= 0x000002,
	LO_SSL		= 0x000004,
	LO_FILTER      	= 0x000008,
	LO_PKI      	= 0x000010,
	LO_AUTH      	= 0x000020,
	LO_TAG      	= 0x000040,
	LO_HOSTNAME   	= 0x000080,
	LO_HOSTNAMES   	= 0x000100,
	LO_MASKSOURCE  	= 0x000200,
	LO_NODSN	= 0x000400,
	LO_SENDERS	= 0x000800,
	LO_RECEIVEDAUTH = 0x001000,
	LO_MASQUERADE	= 0x002000,
	LO_CA		= 0x004000,
	LO_PROXY       	= 0x008000,
};

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *filtername;
	char	       *pki;
	char	       *ca;
	uint16_t       	auth;
	struct table   *authtable;
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	struct table   *sendertable;
	uint16_t	flags;

	uint32_t       	options;
} listen_opts;

static void	create_sock_listener(struct listen_opts *);
static void	create_if_listener(struct listen_opts *);
static void	config_listener(struct listener *, struct listen_opts *);
static int	host_v4(struct listen_opts *);
static int	host_v6(struct listen_opts *);
static int	host_dns(struct listen_opts *);
static int	interface(struct listen_opts *);

int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

static int config_lo_mask_source(struct listen_opts *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;


#line 229 "../../usr.sbin/smtpd/parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    ACTION = 258,                  /* ACTION  */
    ADMD = 259,                    /* ADMD  */
    ALIAS = 260,                   /* ALIAS  */
    ANY = 261,                     /* ANY  */
    ARROW = 262,                   /* ARROW  */
    AUTH = 263,                    /* AUTH  */
    AUTH_OPTIONAL = 264,           /* AUTH_OPTIONAL  */
    BACKUP = 265,                  /* BACKUP  */
    BOUNCE = 266,                  /* BOUNCE  */
    BYPASS = 267,                  /* BYPASS  */
    CA = 268,                      /* CA  */
    CERT = 269,                    /* CERT  */
    CHAIN = 270,                   /* CHAIN  */
    CHROOT = 271,                  /* CHROOT  */
    CIPHERS = 272,                 /* CIPHERS  */
    COMMIT = 273,                  /* COMMIT  */
    COMPRESSION = 274,             /* COMPRESSION  */
    CONNECT = 275,                 /* CONNECT  */
    DATA = 276,                    /* DATA  */
    DATA_LINE = 277,               /* DATA_LINE  */
    DHE = 278,                     /* DHE  */
    DISCONNECT = 279,              /* DISCONNECT  */
    DOMAIN = 280,                  /* DOMAIN  */
    EHLO = 281,                    /* EHLO  */
    ENABLE = 282,                  /* ENABLE  */
    ENCRYPTION = 283,              /* ENCRYPTION  */
    ERROR = 284,                   /* ERROR  */
    EXPAND_ONLY = 285,             /* EXPAND_ONLY  */
    FCRDNS = 286,                  /* FCRDNS  */
    FILTER = 287,                  /* FILTER  */
    FOR = 288,                     /* FOR  */
    FORWARD_ONLY = 289,            /* FORWARD_ONLY  */
    FROM = 290,                    /* FROM  */
    GROUP = 291,                   /* GROUP  */
    HELO = 292,                    /* HELO  */
    HELO_SRC = 293,                /* HELO_SRC  */
    HOST = 294,                    /* HOST  */
    HOSTNAME = 295,                /* HOSTNAME  */
    HOSTNAMES = 296,               /* HOSTNAMES  */
    INCLUDE = 297,                 /* INCLUDE  */
    INET4 = 298,                   /* INET4  */
    INET6 = 299,                   /* INET6  */
    JUNK = 300,                    /* JUNK  */
    KEY = 301,                     /* KEY  */
    LIMIT = 302,                   /* LIMIT  */
    LISTEN = 303,                  /* LISTEN  */
    LMTP = 304,                    /* LMTP  */
    LOCAL = 305,                   /* LOCAL  */
    MAIL_FROM = 306,               /* MAIL_FROM  */
    MAILDIR = 307,                 /* MAILDIR  */
    MASK_SRC = 308,                /* MASK_SRC  */
    MASQUERADE = 309,              /* MASQUERADE  */
    MATCH = 310,                   /* MATCH  */
    MAX_MESSAGE_SIZE = 311,        /* MAX_MESSAGE_SIZE  */
    MAX_DEFERRED = 312,            /* MAX_DEFERRED  */
    MBOX = 313,                    /* MBOX  */
    MDA = 314,                     /* MDA  */
    MTA = 315,                     /* MTA  */
    MX = 316,                      /* MX  */
    NO_DSN = 317,                  /* NO_DSN  */
    NO_VERIFY = 318,               /* NO_VERIFY  */
    NOOP = 319,                    /* NOOP  */
    ON = 320,                      /* ON  */
    PHASE = 321,                   /* PHASE  */
    PKI = 322,                     /* PKI  */
    PORT = 323,                    /* PORT  */
    PROC = 324,                    /* PROC  */
    PROC_EXEC = 325,               /* PROC_EXEC  */
    PROXY_V2 = 326,                /* PROXY_V2  */
    QUEUE = 327,                   /* QUEUE  */
    QUIT = 328,                    /* QUIT  */
    RCPT_TO = 329,                 /* RCPT_TO  */
    RDNS = 330,                    /* RDNS  */
    RECIPIENT = 331,               /* RECIPIENT  */
    RECEIVEDAUTH = 332,            /* RECEIVEDAUTH  */
    REGEX = 333,                   /* REGEX  */
    RELAY = 334,                   /* RELAY  */
    REJECT = 335,                  /* REJECT  */
    REPORT = 336,                  /* REPORT  */
    REWRITE = 337,                 /* REWRITE  */
    RSET = 338,                    /* RSET  */
    SCHEDULER = 339,               /* SCHEDULER  */
    SENDER = 340,                  /* SENDER  */
    SENDERS = 341,                 /* SENDERS  */
    SMTP = 342,                    /* SMTP  */
    SMTP_IN = 343,                 /* SMTP_IN  */
    SMTP_OUT = 344,                /* SMTP_OUT  */
    SMTPS = 345,                   /* SMTPS  */
    SOCKET = 346,                  /* SOCKET  */
    SRC = 347,                     /* SRC  */
    SRS = 348,                     /* SRS  */
    SUB_ADDR_DELIM = 349,          /* SUB_ADDR_DELIM  */
    TABLE = 350,                   /* TABLE  */
    TAG = 351,                     /* TAG  */
    TAGGED = 352,                  /* TAGGED  */
    TLS = 353,                     /* TLS  */
    TLS_REQUIRE = 354,             /* TLS_REQUIRE  */
    TTL = 355,                     /* TTL  */
    USER = 356,                    /* USER  */
    USERBASE = 357,                /* USERBASE  */
    VERIFY = 358,                  /* VERIFY  */
    VIRTUAL = 359,                 /* VIRTUAL  */
    WARN_INTERVAL = 360,           /* WARN_INTERVAL  */
    WRAPPER = 361,                 /* WRAPPER  */
    STRING = 362,                  /* STRING  */
    NUMBER = 363                   /* NUMBER  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define ACTION 258
#define ADMD 259
#define ALIAS 260
#define ANY 261
#define ARROW 262
#define AUTH 263
#define AUTH_OPTIONAL 264
#define BACKUP 265
#define BOUNCE 266
#define BYPASS 267
#define CA 268
#define CERT 269
#define CHAIN 270
#define CHROOT 271
#define CIPHERS 272
#define COMMIT 273
#define COMPRESSION 274
#define CONNECT 275
#define DATA 276
#define DATA_LINE 277
#define DHE 278
#define DISCONNECT 279
#define DOMAIN 280
#define EHLO 281
#define ENABLE 282
#define ENCRYPTION 283
#define ERROR 284
#define EXPAND_ONLY 285
#define FCRDNS 286
#define FILTER 287
#define FOR 288
#define FORWARD_ONLY 289
#define FROM 290
#define GROUP 291
#define HELO 292
#define HELO_SRC 293
#define HOST 294
#define HOSTNAME 295
#define HOSTNAMES 296
#define INCLUDE 297
#define INET4 298
#define INET6 299
#define JUNK 300
#define KEY 301
#define LIMIT 302
#define LISTEN 303
#define LMTP 304
#define LOCAL 305
#define MAIL_FROM 306
#define MAILDIR 307
#define MASK_SRC 308
#define MASQUERADE 309
#define MATCH 310
#define MAX_MESSAGE_SIZE 311
#define MAX_DEFERRED 312
#define MBOX 313
#define MDA 314
#define MTA 315
#define MX 316
#define NO_DSN 317
#define NO_VERIFY 318
#define NOOP 319
#define ON 320
#define PHASE 321
#define PKI 322
#define PORT 323
#define PROC 324
#define PROC_EXEC 325
#define PROXY_V2 326
#define QUEUE 327
#define QUIT 328
#define RCPT_TO 329
#define RDNS 330
#define RECIPIENT 331
#define RECEIVEDAUTH 332
#define REGEX 333
#define RELAY 334
#define REJECT 335
#define REPORT 336
#define REWRITE 337
#define RSET 338
#define SCHEDULER 339
#define SENDER 340
#define SENDERS 341
#define SMTP 342
#define SMTP_IN 343
#define SMTP_OUT 344
#define SMTPS 345
#define SOCKET 346
#define SRC 347
#define SRS 348
#define SUB_ADDR_DELIM 349
#define TABLE 350
#define TAG 351
#define TAGGED 352
#define TLS 353
#define TLS_REQUIRE 354
#define TTL 355
#define USER 356
#define USERBASE 357
#define VERIFY 358
#define VIRTUAL 359
#define WARN_INTERVAL 360
#define WRAPPER 361
#define STRING 362
#define NUMBER 363

/* Value type.  */


extern YYSTYPE yylval;


int yyparse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ACTION = 3,                     /* ACTION  */
  YYSYMBOL_ADMD = 4,                       /* ADMD  */
  YYSYMBOL_ALIAS = 5,                      /* ALIAS  */
  YYSYMBOL_ANY = 6,                        /* ANY  */
  YYSYMBOL_ARROW = 7,                      /* ARROW  */
  YYSYMBOL_AUTH = 8,                       /* AUTH  */
  YYSYMBOL_AUTH_OPTIONAL = 9,              /* AUTH_OPTIONAL  */
  YYSYMBOL_BACKUP = 10,                    /* BACKUP  */
  YYSYMBOL_BOUNCE = 11,                    /* BOUNCE  */
  YYSYMBOL_BYPASS = 12,                    /* BYPASS  */
  YYSYMBOL_CA = 13,                        /* CA  */
  YYSYMBOL_CERT = 14,                      /* CERT  */
  YYSYMBOL_CHAIN = 15,                     /* CHAIN  */
  YYSYMBOL_CHROOT = 16,                    /* CHROOT  */
  YYSYMBOL_CIPHERS = 17,                   /* CIPHERS  */
  YYSYMBOL_COMMIT = 18,                    /* COMMIT  */
  YYSYMBOL_COMPRESSION = 19,               /* COMPRESSION  */
  YYSYMBOL_CONNECT = 20,                   /* CONNECT  */
  YYSYMBOL_DATA = 21,                      /* DATA  */
  YYSYMBOL_DATA_LINE = 22,                 /* DATA_LINE  */
  YYSYMBOL_DHE = 23,                       /* DHE  */
  YYSYMBOL_DISCONNECT = 24,                /* DISCONNECT  */
  YYSYMBOL_DOMAIN = 25,                    /* DOMAIN  */
  YYSYMBOL_EHLO = 26,                      /* EHLO  */
  YYSYMBOL_ENABLE = 27,                    /* ENABLE  */
  YYSYMBOL_ENCRYPTION = 28,                /* ENCRYPTION  */
  YYSYMBOL_ERROR = 29,                     /* ERROR  */
  YYSYMBOL_EXPAND_ONLY = 30,               /* EXPAND_ONLY  */
  YYSYMBOL_FCRDNS = 31,                    /* FCRDNS  */
  YYSYMBOL_FILTER = 32,                    /* FILTER  */
  YYSYMBOL_FOR = 33,                       /* FOR  */
  YYSYMBOL_FORWARD_ONLY = 34,              /* FORWARD_ONLY  */
  YYSYMBOL_FROM = 35,                      /* FROM  */
  YYSYMBOL_GROUP = 36,                     /* GROUP  */
  YYSYMBOL_HELO = 37,                      /* HELO  */
  YYSYMBOL_HELO_SRC = 38,                  /* HELO_SRC  */
  YYSYMBOL_HOST = 39,                      /* HOST  */
  YYSYMBOL_HOSTNAME = 40,                  /* HOSTNAME  */
  YYSYMBOL_HOSTNAMES = 41,                 /* HOSTNAMES  */
  YYSYMBOL_INCLUDE = 42,                   /* INCLUDE  */
  YYSYMBOL_INET4 = 43,                     /* INET4  */
  YYSYMBOL_INET6 = 44,                     /* INET6  */
  YYSYMBOL_JUNK = 45,                      /* JUNK  */
  YYSYMBOL_KEY = 46,                       /* KEY  */
  YYSYMBOL_LIMIT = 47,                     /* LIMIT  */
  YYSYMBOL_LISTEN = 48,                    /* LISTEN  */
  YYSYMBOL_LMTP = 49,                      /* LMTP  */
  YYSYMBOL_LOCAL = 50,                     /* LOCAL  */
  YYSYMBOL_MAIL_FROM = 51,                 /* MAIL_FROM  */
  YYSYMBOL_MAILDIR = 52,                   /* MAILDIR  */
  YYSYMBOL_MASK_SRC = 53,                  /* MASK_SRC  */
  YYSYMBOL_MASQUERADE = 54,                /* MASQUERADE  */
  YYSYMBOL_MATCH = 55,                     /* MATCH  */
  YYSYMBOL_MAX_MESSAGE_SIZE = 56,          /* MAX_MESSAGE_SIZE  */
  YYSYMBOL_MAX_DEFERRED = 57,              /* MAX_DEFERRED  */
  YYSYMBOL_MBOX = 58,                      /* MBOX  */
  YYSYMBOL_MDA = 59,                       /* MDA  */
  YYSYMBOL_MTA = 60,                       /* MTA  */
  YYSYMBOL_MX = 61,                        /* MX  */
  YYSYMBOL_NO_DSN = 62,                    /* NO_DSN  */
  YYSYMBOL_NO_VERIFY = 63,                 /* NO_VERIFY  */
  YYSYMBOL_NOOP = 64,                      /* NOOP  */
  YYSYMBOL_ON = 65,                        /* ON  */
  YYSYMBOL_PHASE = 66,                     /* PHASE  */
  YYSYMBOL_PKI = 67,                       /* PKI  */
  YYSYMBOL_PORT = 68,                      /* PORT  */
  YYSYMBOL_PROC = 69,                      /* PROC  */
  YYSYMBOL_PROC_EXEC = 70,                 /* PROC_EXEC  */
  YYSYMBOL_PROXY_V2 = 71,                  /* PROXY_V2  */
  YYSYMBOL_QUEUE = 72,                     /* QUEUE  */
  YYSYMBOL_QUIT = 73,                      /* QUIT  */
  YYSYMBOL_RCPT_TO = 74,                   /* RCPT_TO  */
  YYSYMBOL_RDNS = 75,                      /* RDNS  */
  YYSYMBOL_RECIPIENT = 76,                 /* RECIPIENT  */
  YYSYMBOL_RECEIVEDAUTH = 77,              /* RECEIVEDAUTH  */
  YYSYMBOL_REGEX = 78,                     /* REGEX  */
  YYSYMBOL_RELAY = 79,                     /* RELAY  */
  YYSYMBOL_REJECT = 80,                    /* REJECT  */
  YYSYMBOL_REPORT = 81,                    /* REPORT  */
  YYSYMBOL_REWRITE = 82,                   /* REWRITE  */
  YYSYMBOL_RSET = 83,                      /* RSET  */
  YYSYMBOL_SCHEDULER = 84,                 /* SCHEDULER  */
  YYSYMBOL_SENDER = 85,                    /* SENDER  */
  YYSYMBOL_SENDERS = 86,                   /* SENDERS  */
  YYSYMBOL_SMTP = 87,                      /* SMTP  */
  YYSYMBOL_SMTP_IN = 88,                   /* SMTP_IN  */
  YYSYMBOL_SMTP_OUT = 89,                  /* SMTP_OUT  */
  YYSYMBOL_SMTPS = 90,                     /* SMTPS  */
  YYSYMBOL_SOCKET = 91,                    /* SOCKET  */
  YYSYMBOL_SRC = 92,                       /* SRC  */
  YYSYMBOL_SRS = 93,                       /* SRS  */
  YYSYMBOL_SUB_ADDR_DELIM = 94,            /* SUB_ADDR_DELIM  */
  YYSYMBOL_TABLE = 95,                     /* TABLE  */
  YYSYMBOL_TAG = 96,                       /* TAG  */
  YYSYMBOL_TAGGED = 97,                    /* TAGGED  */
  YYSYMBOL_TLS = 98,                       /* TLS  */
  YYSYMBOL_TLS_REQUIRE = 99,               /* TLS_REQUIRE  */
  YYSYMBOL_TTL = 100,                      /* TTL  */
  YYSYMBOL_USER = 101,                     /* USER  */
  YYSYMBOL_USERBASE = 102,                 /* USERBASE  */
  YYSYMBOL_VERIFY = 103,                   /* VERIFY  */
  YYSYMBOL_VIRTUAL = 104,                  /* VIRTUAL  */
  YYSYMBOL_WARN_INTERVAL = 105,            /* WARN_INTERVAL  */
  YYSYMBOL_WRAPPER = 106,                  /* WRAPPER  */
  YYSYMBOL_STRING = 107,                   /* STRING  */
  YYSYMBOL_NUMBER = 108,                   /* NUMBER  */
  YYSYMBOL_109_n_ = 109,                   /* '\n'  */
  YYSYMBOL_110_ = 110,                     /* '='  */
  YYSYMBOL_111_ = 111,                     /* ','  */
  YYSYMBOL_112_ = 112,                     /* '!'  */
  YYSYMBOL_113_ = 113,                     /* '{'  */
  YYSYMBOL_114_ = 114,                     /* '}'  */
  YYSYMBOL_115_ = 115,                     /* '<'  */
  YYSYMBOL_116_ = 116,                     /* '>'  */
  YYSYMBOL_YYACCEPT = 117,                 /* $accept  */
  YYSYMBOL_grammar = 118,                  /* grammar  */
  YYSYMBOL_include = 119,                  /* include  */
  YYSYMBOL_varset = 120,                   /* varset  */
  YYSYMBOL_comma = 121,                    /* comma  */
  YYSYMBOL_optnl = 122,                    /* optnl  */
  YYSYMBOL_nl = 123,                       /* nl  */
  YYSYMBOL_negation = 124,                 /* negation  */
  YYSYMBOL_assign = 125,                   /* assign  */
  YYSYMBOL_keyval = 126,                   /* keyval  */
  YYSYMBOL_keyval_list = 127,              /* keyval_list  */
  YYSYMBOL_stringel = 128,                 /* stringel  */
  YYSYMBOL_string_list = 129,              /* string_list  */
  YYSYMBOL_tableval_list = 130,            /* tableval_list  */
  YYSYMBOL_bounce = 131,                   /* bounce  */
  YYSYMBOL_132_1 = 132,                    /* $@1  */
  YYSYMBOL_admd = 133,                     /* admd  */
  YYSYMBOL_ca = 134,                       /* ca  */
  YYSYMBOL_135_2 = 135,                    /* $@2  */
  YYSYMBOL_ca_params_opt = 136,            /* ca_params_opt  */
  YYSYMBOL_ca_params = 137,                /* ca_params  */
  YYSYMBOL_mda = 138,                      /* mda  */
  YYSYMBOL_mta = 139,                      /* mta  */
  YYSYMBOL_140_3 = 140,                    /* $@3  */
  YYSYMBOL_141_4 = 141,                    /* $@4  */
  YYSYMBOL_pki = 142,                      /* pki  */
  YYSYMBOL_143_5 = 143,                    /* $@5  */
  YYSYMBOL_pki_params_opt = 144,           /* pki_params_opt  */
  YYSYMBOL_pki_params = 145,               /* pki_params  */
  YYSYMBOL_proc = 146,                     /* proc  */
  YYSYMBOL_147_6 = 147,                    /* $@6  */
  YYSYMBOL_proc_params_opt = 148,          /* proc_params_opt  */
  YYSYMBOL_proc_params = 149,              /* proc_params  */
  YYSYMBOL_queue = 150,                    /* queue  */
  YYSYMBOL_scheduler = 151,                /* scheduler  */
  YYSYMBOL_smtp = 152,                     /* smtp  */
  YYSYMBOL_srs = 153,                      /* srs  */
  YYSYMBOL_dispatcher_local_option = 154,  /* dispatcher_local_option  */
  YYSYMBOL_dispatcher_local_options = 155, /* dispatcher_local_options  */
  YYSYMBOL_dispatcher_local = 156,         /* dispatcher_local  */
  YYSYMBOL_157_7 = 157,                    /* $@7  */
  YYSYMBOL_158_8 = 158,                    /* $@8  */
  YYSYMBOL_159_9 = 159,                    /* $@9  */
  YYSYMBOL_160_10 = 160,                   /* $@10  */
  YYSYMBOL_161_11 = 161,                   /* $@11  */
  YYSYMBOL_162_12 = 162,                   /* $@12  */
  YYSYMBOL_163_13 = 163,                   /* $@13  */
  YYSYMBOL_164_14 = 164,                   /* $@14  */
  YYSYMBOL_165_15 = 165,                   /* $@15  */
  YYSYMBOL_166_16 = 166,                   /* $@16  */
  YYSYMBOL_dispatcher_remote_option = 167, /* dispatcher_remote_option  */
  YYSYMBOL_168_17 = 168,                   /* $@17  */
  YYSYMBOL_dispatcher_remote_options = 169, /* dispatcher_remote_options  */
  YYSYMBOL_dispatcher_remote = 170,        /* dispatcher_remote  */
  YYSYMBOL_dispatcher_type = 171,          /* dispatcher_type  */
  YYSYMBOL_dispatcher_option = 172,        /* dispatcher_option  */
  YYSYMBOL_dispatcher_options = 173,       /* dispatcher_options  */
  YYSYMBOL_dispatcher = 174,               /* dispatcher  */
  YYSYMBOL_175_18 = 175,                   /* $@18  */
  YYSYMBOL_match_option = 176,             /* match_option  */
  YYSYMBOL_match_options = 177,            /* match_options  */
  YYSYMBOL_match_dispatcher = 178,         /* match_dispatcher  */
  YYSYMBOL_action = 179,                   /* action  */
  YYSYMBOL_match = 180,                    /* match  */
  YYSYMBOL_181_19 = 181,                   /* $@19  */
  YYSYMBOL_filter_action_builtin = 182,    /* filter_action_builtin  */
  YYSYMBOL_filter_action_builtin_nojunk = 183, /* filter_action_builtin_nojunk  */
  YYSYMBOL_filter_phase_check_fcrdns = 184, /* filter_phase_check_fcrdns  */
  YYSYMBOL_filter_phase_check_rdns = 185,  /* filter_phase_check_rdns  */
  YYSYMBOL_filter_phase_check_rdns_table = 186, /* filter_phase_check_rdns_table  */
  YYSYMBOL_filter_phase_check_rdns_regex = 187, /* filter_phase_check_rdns_regex  */
  YYSYMBOL_filter_phase_check_src_table = 188, /* filter_phase_check_src_table  */
  YYSYMBOL_filter_phase_check_src_regex = 189, /* filter_phase_check_src_regex  */
  YYSYMBOL_filter_phase_check_helo_table = 190, /* filter_phase_check_helo_table  */
  YYSYMBOL_filter_phase_check_helo_regex = 191, /* filter_phase_check_helo_regex  */
  YYSYMBOL_filter_phase_check_auth = 192,  /* filter_phase_check_auth  */
  YYSYMBOL_filter_phase_check_auth_table = 193, /* filter_phase_check_auth_table  */
  YYSYMBOL_filter_phase_check_auth_regex = 194, /* filter_phase_check_auth_regex  */
  YYSYMBOL_filter_phase_check_mail_from_table = 195, /* filter_phase_check_mail_from_table  */
  YYSYMBOL_filter_phase_check_mail_from_regex = 196, /* filter_phase_check_mail_from_regex  */
  YYSYMBOL_filter_phase_check_rcpt_to_table = 197, /* filter_phase_check_rcpt_to_table  */
  YYSYMBOL_filter_phase_check_rcpt_to_regex = 198, /* filter_phase_check_rcpt_to_regex  */
  YYSYMBOL_filter_phase_global_options = 199, /* filter_phase_global_options  */
  YYSYMBOL_filter_phase_connect_options = 200, /* filter_phase_connect_options  */
  YYSYMBOL_filter_phase_helo_options = 201, /* filter_phase_helo_options  */
  YYSYMBOL_filter_phase_auth_options = 202, /* filter_phase_auth_options  */
  YYSYMBOL_filter_phase_mail_from_options = 203, /* filter_phase_mail_from_options  */
  YYSYMBOL_filter_phase_rcpt_to_options = 204, /* filter_phase_rcpt_to_options  */
  YYSYMBOL_filter_phase_data_options = 205, /* filter_phase_data_options  */
  YYSYMBOL_filter_phase_commit_options = 206, /* filter_phase_commit_options  */
  YYSYMBOL_filter_phase_connect = 207,     /* filter_phase_connect  */
  YYSYMBOL_208_20 = 208,                   /* $@20  */
  YYSYMBOL_filter_phase_helo = 209,        /* filter_phase_helo  */
  YYSYMBOL_210_21 = 210,                   /* $@21  */
  YYSYMBOL_filter_phase_ehlo = 211,        /* filter_phase_ehlo  */
  YYSYMBOL_212_22 = 212,                   /* $@22  */
  YYSYMBOL_filter_phase_auth = 213,        /* filter_phase_auth  */
  YYSYMBOL_214_23 = 214,                   /* $@23  */
  YYSYMBOL_filter_phase_mail_from = 215,   /* filter_phase_mail_from  */
  YYSYMBOL_216_24 = 216,                   /* $@24  */
  YYSYMBOL_filter_phase_rcpt_to = 217,     /* filter_phase_rcpt_to  */
  YYSYMBOL_218_25 = 218,                   /* $@25  */
  YYSYMBOL_filter_phase_data = 219,        /* filter_phase_data  */
  YYSYMBOL_220_26 = 220,                   /* $@26  */
  YYSYMBOL_filter_phase_commit = 221,      /* filter_phase_commit  */
  YYSYMBOL_222_27 = 222,                   /* $@27  */
  YYSYMBOL_filter_phase = 223,             /* filter_phase  */
  YYSYMBOL_filterel = 224,                 /* filterel  */
  YYSYMBOL_filter_list = 225,              /* filter_list  */
  YYSYMBOL_filter = 226,                   /* filter  */
  YYSYMBOL_227_28 = 227,                   /* $@28  */
  YYSYMBOL_228_29 = 228,                   /* $@29  */
  YYSYMBOL_229_30 = 229,                   /* $@30  */
  YYSYMBOL_size = 230,                     /* size  */
  YYSYMBOL_bouncedelay = 231,              /* bouncedelay  */
  YYSYMBOL_bouncedelays = 232,             /* bouncedelays  */
  YYSYMBOL_opt_limit_mda = 233,            /* opt_limit_mda  */
  YYSYMBOL_limits_smtp = 234,              /* limits_smtp  */
  YYSYMBOL_opt_limit_smtp = 235,           /* opt_limit_smtp  */
  YYSYMBOL_limits_mda = 236,               /* limits_mda  */
  YYSYMBOL_opt_limit_mta = 237,            /* opt_limit_mta  */
  YYSYMBOL_limits_mta = 238,               /* limits_mta  */
  YYSYMBOL_opt_limit_scheduler = 239,      /* opt_limit_scheduler  */
  YYSYMBOL_limits_scheduler = 240,         /* limits_scheduler  */
  YYSYMBOL_opt_sock_listen = 241,          /* opt_sock_listen  */
  YYSYMBOL_242_31 = 242,                   /* $@31  */
  YYSYMBOL_opt_if_listen = 243,            /* opt_if_listen  */
  YYSYMBOL_244_32 = 244,                   /* $@32  */
  YYSYMBOL_listener_type = 245,            /* listener_type  */
  YYSYMBOL_socket_listener = 246,          /* socket_listener  */
  YYSYMBOL_if_listener = 247,              /* if_listener  */
  YYSYMBOL_sock_listen = 248,              /* sock_listen  */
  YYSYMBOL_if_listen = 249,                /* if_listen  */
  YYSYMBOL_listen = 250,                   /* listen  */
  YYSYMBOL_251_33 = 251,                   /* $@33  */
  YYSYMBOL_table = 252,                    /* table  */
  YYSYMBOL_253_34 = 253,                   /* $@34  */
  YYSYMBOL_tablenew = 254,                 /* tablenew  */
  YYSYMBOL_255_35 = 255,                   /* $@35  */
  YYSYMBOL_tableref = 256,                 /* tableref  */
  YYSYMBOL_tables = 257                    /* tables  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   507

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  117
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  141
/* YYNRULES -- Number of rules.  */
#define YYNRULES  352
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  563

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   363


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     109,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   112,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   111,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     115,   110,   116,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   113,     2,   114,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   213,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   236,   251,   269,   270,   271,   274,   275,
     278,   281,   282,   285,   285,   288,   295,   296,   299,   305,
     306,   309,   310,   314,   314,   321,   336,   336,   360,   366,
     371,   372,   383,   386,   386,   398,   398,   405,   405,   428,
     431,   434,   452,   453,   458,   458,   475,   483,   491,   502,
     503,   508,   511,   514,   523,   536,   541,   542,   545,   548,
     564,   567,   570,   590,   613,   634,   655,   671,   681,   682,
     686,   686,   690,   690,   693,   693,   696,   696,   704,   704,
     712,   712,   716,   716,   720,   720,   724,   724,   727,   727,
     734,   742,   757,   765,   773,   789,   797,   810,   822,   842,
     863,   871,   880,   901,   917,   917,   940,   955,   956,   960,
     964,   967,   973,   990,   991,   995,   995,  1011,  1029,  1048,
    1065,  1083,  1090,  1097,  1114,  1132,  1149,  1167,  1184,  1203,
    1211,  1221,  1231,  1248,  1266,  1274,  1292,  1312,  1324,  1344,
    1366,  1386,  1408,  1418,  1428,  1445,  1463,  1483,  1507,  1508,
    1512,  1522,  1525,  1529,  1529,  1546,  1547,  1550,  1556,  1559,
    1562,  1565,  1571,  1578,  1585,  1591,  1598,  1604,  1611,  1617,
    1624,  1630,  1636,  1643,  1649,  1656,  1662,  1669,  1670,  1671,
    1672,  1673,  1674,  1677,  1680,  1681,  1682,  1685,  1686,  1687,
    1688,  1689,  1690,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1742,
    1743,  1744,  1745,  1746,  1747,  1748,  1749,  1753,  1753,  1760,
    1760,  1766,  1766,  1772,  1772,  1777,  1777,  1783,  1783,  1789,
    1789,  1821,  1821,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1840,  1845,  1888,  1889,  1893,  1916,  1916,  1938,  1938,  1952,
    1952,  1967,  1974,  1987,  2007,  2008,  2011,  2036,  2037,  2040,
    2056,  2057,  2060,  2063,  2066,  2076,  2077,  2080,  2102,  2103,
    2107,  2124,  2124,  2146,  2151,  2167,  2175,  2183,  2201,  2217,
    2233,  2246,  2262,  2262,  2284,  2292,  2300,  2308,  2316,  2324,
    2332,  2340,  2348,  2356,  2365,  2374,  2388,  2397,  2413,  2418,
    2426,  2434,  2442,  2458,  2476,  2477,  2480,  2489,  2495,  2496,
    2499,  2500,  2504,  2504,  2511,  2549,  2549,  2557,  2565,  2565,
    2573,  2586,  2587
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ACTION", "ADMD",
  "ALIAS", "ANY", "ARROW", "AUTH", "AUTH_OPTIONAL", "BACKUP", "BOUNCE",
  "BYPASS", "CA", "CERT", "CHAIN", "CHROOT", "CIPHERS", "COMMIT",
  "COMPRESSION", "CONNECT", "DATA", "DATA_LINE", "DHE", "DISCONNECT",
  "DOMAIN", "EHLO", "ENABLE", "ENCRYPTION", "ERROR", "EXPAND_ONLY",
  "FCRDNS", "FILTER", "FOR", "FORWARD_ONLY", "FROM", "GROUP", "HELO",
  "HELO_SRC", "HOST", "HOSTNAME", "HOSTNAMES", "INCLUDE", "INET4", "INET6",
  "JUNK", "KEY", "LIMIT", "LISTEN", "LMTP", "LOCAL", "MAIL_FROM",
  "MAILDIR", "MASK_SRC", "MASQUERADE", "MATCH", "MAX_MESSAGE_SIZE",
  "MAX_DEFERRED", "MBOX", "MDA", "MTA", "MX", "NO_DSN", "NO_VERIFY",
  "NOOP", "ON", "PHASE", "PKI", "PORT", "PROC", "PROC_EXEC", "PROXY_V2",
  "QUEUE", "QUIT", "RCPT_TO", "RDNS", "RECIPIENT", "RECEIVEDAUTH", "REGEX",
  "RELAY", "REJECT", "REPORT", "REWRITE", "RSET", "SCHEDULER", "SENDER",
  "SENDERS", "SMTP", "SMTP_IN", "SMTP_OUT", "SMTPS", "SOCKET", "SRC",
  "SRS", "SUB_ADDR_DELIM", "TABLE", "TAG", "TAGGED", "TLS", "TLS_REQUIRE",
  "TTL", "USER", "USERBASE", "VERIFY", "VIRTUAL", "WARN_INTERVAL",
  "WRAPPER", "STRING", "NUMBER", "'\\n'", "'='", "','", "'!'", "'{'",
  "'}'", "'<'", "'>'", "$accept", "grammar", "include", "varset", "comma",
  "optnl", "nl", "negation", "assign", "keyval", "keyval_list", "stringel",
  "string_list", "tableval_list", "bounce", "$@1", "admd", "ca", "$@2",
  "ca_params_opt", "ca_params", "mda", "mta", "$@3", "$@4", "pki", "$@5",
  "pki_params_opt", "pki_params", "proc", "$@6", "proc_params_opt",
  "proc_params", "queue", "scheduler", "smtp", "srs",
  "dispatcher_local_option", "dispatcher_local_options",
  "dispatcher_local", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "dispatcher_remote_option", "$@17",
  "dispatcher_remote_options", "dispatcher_remote", "dispatcher_type",
  "dispatcher_option", "dispatcher_options", "dispatcher", "$@18",
  "match_option", "match_options", "match_dispatcher", "action", "match",
  "$@19", "filter_action_builtin", "filter_action_builtin_nojunk",
  "filter_phase_check_fcrdns", "filter_phase_check_rdns",
  "filter_phase_check_rdns_table", "filter_phase_check_rdns_regex",
  "filter_phase_check_src_table", "filter_phase_check_src_regex",
  "filter_phase_check_helo_table", "filter_phase_check_helo_regex",
  "filter_phase_check_auth", "filter_phase_check_auth_table",
  "filter_phase_check_auth_regex", "filter_phase_check_mail_from_table",
  "filter_phase_check_mail_from_regex", "filter_phase_check_rcpt_to_table",
  "filter_phase_check_rcpt_to_regex", "filter_phase_global_options",
  "filter_phase_connect_options", "filter_phase_helo_options",
  "filter_phase_auth_options", "filter_phase_mail_from_options",
  "filter_phase_rcpt_to_options", "filter_phase_data_options",
  "filter_phase_commit_options", "filter_phase_connect", "$@20",
  "filter_phase_helo", "$@21", "filter_phase_ehlo", "$@22",
  "filter_phase_auth", "$@23", "filter_phase_mail_from", "$@24",
  "filter_phase_rcpt_to", "$@25", "filter_phase_data", "$@26",
  "filter_phase_commit", "$@27", "filter_phase", "filterel", "filter_list",
  "filter", "$@28", "$@29", "$@30", "size", "bouncedelay", "bouncedelays",
  "opt_limit_mda", "limits_smtp", "opt_limit_smtp", "limits_mda",
  "opt_limit_mta", "limits_mta", "opt_limit_scheduler", "limits_scheduler",
  "opt_sock_listen", "$@31", "opt_if_listen", "$@32", "listener_type",
  "socket_listener", "if_listener", "sock_listen", "if_listen", "listen",
  "$@33", "table", "$@34", "tablenew", "$@35", "tableref", "tables", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-275)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-273)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -275,    17,  -275,   -82,   -72,   -54,   -51,   -49,   -47,   -46,
    -275,  -275,   -28,     5,   -36,   -32,    14,    53,     8,   -15,
      24,    -4,  -275,    31,    54,    59,    69,    77,    81,    87,
      91,    93,    95,   108,   112,   118,   121,   133,   134,   136,
     140,  -275,  -275,  -275,  -275,  -275,   198,  -275,   129,    10,
      39,   143,   220,   150,  -275,   158,  -275,   165,   168,   172,
     173,   177,   -68,   178,    -2,   182,   184,   195,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,   229,   217,   313,  -275,
    -275,   233,   234,    37,  -275,    -1,    10,    12,   228,    39,
    -275,   246,   329,    25,  -275,    33,  -275,  -275,  -275,   247,
     172,  -275,  -275,   253,  -275,   177,  -275,  -275,  -275,  -275,
     249,  -275,  -275,  -275,   251,  -275,  -275,  -275,   261,   -33,
    -275,   265,   223,  -275,  -275,   281,  -275,  -275,   271,   279,
    -275,  -275,   275,   161,  -275,  -275,   109,   148,  -275,  -275,
    -275,    70,   110,    16,    96,   179,   188,   191,  -275,  -275,
     290,  -275,  -275,  -275,  -275,  -275,   291,  -275,  -275,   292,
      25,  -275,   300,   305,   307,    33,  -275,    -7,  -275,  -275,
    -275,  -275,  -275,   308,    41,    41,   346,  -275,   377,    41,
      41,  -275,    57,   362,   320,    57,   322,   323,    57,    57,
     327,   330,    57,  -275,   379,   223,  -275,   336,   281,  -275,
     217,  -275,   339,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
      -7,   340,  -275,   341,   109,  -275,    57,    57,   342,   343,
     344,    57,  -275,  -275,  -275,  -275,   345,    68,  -275,  -275,
      57,   350,   347,  -275,   352,   148,  -275,    57,  -275,  -275,
     349,  -275,  -275,  -275,  -275,   192,  -275,   204,  -275,   205,
    -275,   215,   218,  -275,   219,    57,  -275,    57,  -275,    57,
    -275,    57,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,   351,   353,   354,    -7,  -275,     9,   248,  -275,
     260,  -275,   348,    57,   356,    57,    57,   357,    41,  -275,
    -275,  -275,    41,    41,  -275,    41,  -275,  -275,    41,  -275,
     358,  -275,  -275,  -275,   355,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,   324,   359,   402,
     404,   411,   412,   414,   415,   416,   417,  -275,  -275,   361,
    -275,  -275,  -275,  -275,  -275,  -275,   363,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,   421,  -275,  -275,  -275,  -275,  -275,
     308,   364,    57,  -275,    57,  -275,    57,  -275,    57,  -275,
      57,  -275,    57,  -275,  -275,  -275,  -275,  -275,    25,  -275,
    -275,  -275,  -275,  -275,  -275,   370,   369,  -275,   372,  -275,
     374,  -275,  -275,  -275,  -275,  -275,  -275,  -275,    41,  -275,
    -275,    41,  -275,  -275,  -275,   339,   339,  -275,   371,   371,
     371,   371,   371,   371,   371,   371,   339,   339,  -275,   368,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,   369,
    -275,     9,  -275,  -275,  -275,  -275,  -275,   373,  -275,    62,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,   126,   122,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,    85,   164,  -275,   126,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,   126,   162,  -275,  -275,  -275,   126,
     126,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,   126,
       6,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,   126,   375,   376,  -275,  -275,  -275,   222,  -275,   231,
     232,   235,  -275,   378,  -275,   381,   384,   385,  -275,  -275,
     236,  -275,  -275,  -275,  -275,  -275,  -275,   245,  -275,  -275,
    -275,    57,  -275,    57,  -275,    57,  -275,    57,  -275,  -275,
    -275,  -275,  -275,    57,  -275,    57,  -275,  -275,  -275,  -275,
    -275,  -275,  -275
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,     0,
     342,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,   135,    45,    43,    46,     0,    23,     0,    32,
     291,     0,    55,     0,    57,     0,    71,    72,     0,   299,
       0,   288,     0,     0,     0,     0,   345,     0,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    19,    20,    21,    17,    18,     0,     0,     0,   279,
     277,     0,     0,     0,    31,     0,    32,     0,     0,   291,
      50,     0,     0,   296,    52,    63,    64,    73,    74,     0,
     299,    75,    77,     0,    76,   288,   282,   281,    78,    79,
       0,    80,    82,   344,     0,    24,   108,   106,     0,    92,
      90,     0,   128,   130,   131,   134,   283,   285,    44,     0,
      49,    47,     0,     0,   274,   275,   339,   341,   343,   334,
     335,   142,     0,     0,     0,     0,     0,     0,   141,   168,
       0,   171,   174,   286,   290,    51,     0,   292,   293,     0,
     296,    56,     0,     0,     0,    63,    58,    70,   297,   298,
     289,   287,    81,     0,    89,    89,   100,    94,    96,    89,
      89,   104,     0,   117,     0,     0,   124,     0,     0,     0,
       0,     0,     0,   126,   120,   128,   129,     0,   134,   136,
       0,    48,     0,   253,   261,   247,   259,   251,   249,   255,
     257,   263,   264,   265,   266,   267,   268,   269,   270,   278,
      70,   301,   303,     0,   339,   336,   321,   322,     0,   312,
       0,     0,   305,   306,   328,   330,     0,     0,   331,   329,
       0,   314,     0,   316,   317,   341,   337,     0,   347,   348,
       0,   351,   352,   143,   163,     0,   162,     0,   151,   157,
     150,     0,   154,   149,     0,     0,   139,     0,   145,     0,
     147,     0,   137,   170,   172,    53,   294,   295,    59,    61,
      60,    62,     0,     0,     0,    70,    65,    38,    27,    42,
      27,    41,     0,     0,     0,     0,     0,     0,    89,   109,
     107,   102,    89,    89,    98,    89,    93,    91,    89,   122,
       0,   113,   119,   123,     0,   110,   111,   118,   115,   112,
     114,   121,   127,   132,   133,   284,   271,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   276,   300,     0,
     304,   338,   323,   324,   320,   311,     0,   326,   327,   319,
     308,   309,   307,   310,   332,   315,   325,   318,   340,   144,
       0,     0,     0,   164,     0,   166,     0,   158,     0,   160,
       0,   155,     0,   152,   140,   146,   148,   138,   296,    68,
      67,    66,    69,    34,    33,     0,    29,    25,     0,    26,
       0,   346,    84,    83,    86,    85,    87,    88,    89,   101,
      95,    89,    97,   105,   116,     0,     0,   280,    32,    32,
      32,    32,    32,    32,    32,    32,     0,     0,   333,     0,
     350,   165,   167,   159,   161,   156,   153,    54,    35,    29,
      30,     0,    37,    38,    40,   103,    99,     0,   273,     0,
     197,   198,   200,   199,   202,   201,   207,   208,   209,   210,
     211,   212,     0,     0,   239,   240,   241,   242,   243,   244,
     245,   246,     0,     0,   203,     0,   231,   232,   233,   234,
     235,   236,   237,   238,     0,     0,   204,   205,   206,     0,
       0,   213,   214,   215,   216,   217,   218,   219,   220,     0,
       0,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,     0,     0,     0,   349,    28,   125,   190,   182,     0,
     183,     0,   177,     0,   176,     0,     0,     0,   254,   175,
       0,   262,   248,   260,   252,   250,   256,     0,   258,   302,
     313,     0,   191,     0,   188,     0,   184,     0,   186,   179,
     178,   181,   180,     0,   193,     0,   195,   192,   189,   185,
     187,   194,   196
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -275,  -275,  -275,  -275,  -274,    45,  -275,   -45,  -275,  -275,
      88,  -275,    94,   123,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,   321,  -275,
    -275,  -275,  -207,  -275,  -275,  -275,  -275,  -275,  -179,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,   293,  -275,  -275,  -275,   287,  -275,  -275,  -275,
     401,  -275,  -275,  -275,  -275,  -105,    27,  -275,  -275,  -275,
    -275,  -275,  -275,    -8,     0,  -148,   -29,     7,    15,    20,
    -275,  -275,   -16,  -275,    78,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,  -275,  -275,  -275,  -275,  -275,  -275,  -275,  -175,  -275,
    -275,  -275,  -275,  -275,   294,  -275,  -275,   387,  -275,   406,
    -275,  -165,  -275,   390,  -275,  -275,  -275,  -275,  -275,  -275,
    -275,   269,   252,  -275,  -275,  -275,  -275,  -275,  -275,  -275,
    -154
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    23,    24,   398,   440,   399,   463,   395,   298,
     299,   300,   301,   302,    25,    87,    26,    27,    88,   140,
     141,    28,    29,   388,   103,    30,   105,   175,   176,    31,
     177,   295,   296,    32,    33,    34,    35,   308,   309,   133,
     190,   189,   313,   315,   411,   312,   408,   318,   185,   184,
     205,   324,   206,   134,   135,   208,   209,    36,    86,    96,
      97,   284,   162,    37,    49,   528,   529,   450,   451,   452,
     453,   454,   455,   486,   487,   458,   459,   460,   469,   470,
     508,   509,   488,   475,   489,   462,   499,   511,   484,   472,
     221,   341,   222,   344,   223,   343,   224,   339,   225,   345,
     226,   346,   227,   342,   228,   340,   229,   337,   338,    38,
     230,   143,   142,   118,   137,   138,    99,   114,   115,   100,
     170,   171,   110,   111,   234,   349,   255,   356,   148,   149,
     150,   235,   256,    39,    48,    40,   124,   261,   370,   262,
     263
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     276,   278,   280,   282,    95,   287,   310,   151,   120,   292,
     316,   317,   187,  -169,   517,   160,   393,     2,     3,    50,
       4,     5,   268,   347,   269,    60,   400,    41,     6,   293,
       7,    64,   152,    56,   153,    42,   154,   518,   319,   116,
     117,   322,    57,   519,   326,   327,   303,   172,   330,     8,
     155,    95,    52,    43,    44,    61,   173,   530,    45,     9,
      46,    47,    53,   416,    62,    10,   270,   271,   167,   168,
     517,    54,    11,   156,   188,    55,    12,    13,    51,   174,
     537,   520,   352,   353,    14,    65,    15,   358,   392,    16,
    -169,   272,   161,   518,   294,   157,   364,   158,   521,   519,
      59,    17,    63,   369,    18,   121,    67,   273,   274,   523,
      19,   373,    20,   375,    58,   377,   264,   379,   381,   394,
     383,   384,    94,   385,    21,   386,    22,   387,   146,   407,
     517,    66,   169,   409,   410,   265,   412,   520,   522,   413,
      68,   231,   304,   305,   147,   306,    98,   307,   257,   402,
     523,   404,   405,   518,   521,   360,   236,   237,   361,   519,
     266,   238,   232,    69,   258,   525,   526,   527,    70,   213,
     259,   524,   260,   530,   275,   362,   363,   258,    71,   214,
     239,   215,   216,   259,   267,   260,    72,   217,   240,   241,
      73,   242,   243,   518,    93,   518,    74,   520,   218,   519,
      75,   244,    76,   258,    77,   233,   525,   526,   527,   259,
     245,   260,   219,    89,   521,   246,   247,    78,   431,   248,
     432,    79,   433,   437,   434,   249,   435,    80,   436,   445,
      81,   192,   446,   193,   250,   220,   194,   520,   251,   520,
     447,   448,    82,    83,   252,    84,   253,   254,   195,    85,
     101,   512,   513,   102,   521,   196,   521,   277,   104,   126,
     197,   198,   199,   127,    90,   106,   279,    91,    92,   281,
     372,   466,   107,   478,   200,   108,   493,   503,   128,   109,
     112,   129,   374,   376,   113,   119,   258,   130,   131,   122,
     201,   123,   259,   378,   260,   258,   380,   382,   258,   258,
     541,   259,   125,   260,   259,   259,   260,   260,   132,   543,
     545,   258,   258,   547,   553,   202,   203,   259,   259,   260,
     260,   204,   258,   555,   136,   258,   258,   139,   259,   258,
     260,   259,   259,   260,   260,   259,   163,   260,   258,   258,
     144,   145,   258,   258,   259,   259,   260,   260,   259,   259,
     260,   260,   258,   165,   166,   178,   182,   396,   259,   397,
     260,   180,   -36,   542,   183,   544,   546,   548,   186,   396,
     532,   397,   191,   449,   -39,   473,   554,   485,   485,   533,
     500,   207,   210,   556,   534,   535,   211,   557,   212,   558,
     467,   559,   479,   560,   536,   494,   504,   283,   285,   561,
     286,   562,   461,   471,   474,   483,   538,   288,   498,   510,
     456,   464,   289,   476,   290,   297,   491,   501,   457,   465,
     311,   477,   314,   320,   492,   502,   468,   321,   480,   323,
     325,   495,   505,   396,   328,   397,   481,   329,  -272,   496,
     506,   482,   331,   333,   497,   507,   336,   348,   350,   354,
     355,   357,   359,   365,   366,   367,   371,   418,   389,   419,
     390,   391,   401,   403,   406,   414,   420,   421,   415,   422,
     423,   424,   425,   417,   426,   428,   427,   438,   439,   441,
     430,   443,   514,    94,   515,   549,   442,   516,   550,   539,
     540,   551,   552,   429,   444,   334,   291,   159,   332,   531,
     179,   490,   181,   351,   335,   164,     0,   368
};

static const yytype_int16 yycheck[] =
{
     154,   155,   156,   157,    49,   170,   185,     8,    10,    16,
     189,   190,    45,     3,     8,     3,     7,     0,     1,    47,
       3,     4,     6,   230,     8,    17,   300,   109,    11,    36,
      13,    46,    33,    19,    35,   107,    37,    31,   192,   107,
     108,   195,    28,    37,   198,   199,     5,    14,   202,    32,
      51,    96,    47,   107,   105,    47,    23,    51,   107,    42,
     107,   107,    57,   337,    56,    48,    50,    51,    43,    44,
       8,   107,    55,    74,   107,   107,    59,    60,   106,    46,
      74,    75,   236,   237,    67,   100,    69,   241,   295,    72,
      80,    75,    80,    31,   101,    96,   250,    98,    92,    37,
      47,    84,    94,   257,    87,   107,   110,    91,    92,    24,
      93,   265,    95,   267,   100,   269,     6,   271,   272,   110,
     274,   275,   112,   277,   107,   279,   109,   281,    91,   308,
       8,   107,   107,   312,   313,    25,   315,    75,    12,   318,
     109,    32,   101,   102,   107,   104,   107,   106,    78,   303,
      24,   305,   306,    31,    92,    87,     8,     9,    90,    37,
      50,    13,    53,   109,   107,    80,    81,    82,   109,     8,
     113,    45,   115,    51,    78,   107,   108,   107,   109,    18,
      32,    20,    21,   113,    74,   115,   109,    26,    40,    41,
     109,    43,    44,    31,    65,    31,   109,    75,    37,    37,
     109,    53,   109,   107,   109,    96,    80,    81,    82,   113,
      62,   115,    51,    15,    92,    67,    68,   109,   372,    71,
     374,   109,   376,   388,   378,    77,   380,   109,   382,   408,
     109,     8,   411,    10,    86,    74,    13,    75,    90,    75,
     415,   416,   109,   109,    96,   109,    98,    99,    25,   109,
     107,   426,   427,    33,    92,    32,    92,    78,   108,    30,
      37,    38,    39,    34,    66,   107,    78,    69,    70,    78,
      78,   419,   107,   421,    51,   107,   424,   425,    49,   107,
     107,    52,    78,    78,   107,   107,   107,    58,    59,   107,
      67,   107,   113,    78,   115,   107,    78,    78,   107,   107,
      78,   113,   107,   115,   113,   113,   115,   115,    79,    78,
      78,   107,   107,    78,    78,    92,    93,   113,   113,   115,
     115,    98,   107,    78,   107,   107,   107,    14,   113,   107,
     115,   113,   113,   115,   115,   113,   108,   115,   107,   107,
     107,   107,   107,   107,   113,   113,   115,   115,   113,   113,
     115,   115,   107,   107,    25,   108,   107,   109,   113,   111,
     115,   108,   114,   517,   113,   519,   520,   521,   107,   109,
     475,   111,   107,   418,   114,   420,   530,   422,   423,   484,
     425,   100,   111,   537,   489,   490,   107,   541,   113,   543,
     419,   545,   421,   547,   499,   424,   425,   107,   107,   553,
     108,   555,   418,   419,   420,   421,   511,   107,   424,   425,
     418,   419,   107,   421,   107,   107,   424,   425,   418,   419,
      74,   421,    45,    61,   424,   425,   419,   107,   421,   107,
     107,   424,   425,   109,   107,   111,   421,   107,   114,   424,
     425,   421,    63,   107,   424,   425,   107,   107,   107,   107,
     107,   107,   107,   103,   107,   103,   107,    55,   107,    55,
     107,   107,   114,   107,   107,   107,    55,    55,   113,    55,
      55,    55,    55,   114,   113,    54,   113,   107,   109,   107,
     116,   107,   114,   112,   439,   107,   398,   114,   107,   114,
     114,   107,   107,   370,   400,   208,   175,    96,   205,   472,
     110,   423,   115,   234,   210,    99,    -1,   255
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   118,     0,     1,     3,     4,    11,    13,    32,    42,
      48,    55,    59,    60,    67,    69,    72,    84,    87,    93,
      95,   107,   109,   119,   120,   131,   133,   134,   138,   139,
     142,   146,   150,   151,   152,   153,   174,   180,   226,   250,
     252,   109,   107,   107,   105,   107,   107,   107,   251,   181,
      47,   106,    47,    57,   107,   107,    19,    28,   100,    47,
      17,    47,    56,    94,    46,   100,   107,   110,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   175,   132,   135,    15,
      66,    69,    70,    65,   112,   124,   176,   177,   107,   233,
     236,   107,    33,   141,   108,   143,   107,   107,   107,   107,
     239,   240,   107,   107,   234,   235,   107,   108,   230,   107,
      10,   107,   107,   107,   253,   107,    30,    34,    49,    52,
      58,    59,    79,   156,   170,   171,   107,   231,   232,    14,
     136,   137,   229,   228,   107,   107,    91,   107,   245,   246,
     247,     8,    33,    35,    37,    51,    74,    96,    98,   177,
       3,    80,   179,   108,   236,   107,    25,    43,    44,   107,
     237,   238,    14,    23,    46,   144,   145,   147,   108,   240,
     108,   234,   107,   113,   166,   165,   107,    45,   107,   158,
     157,   107,     8,    10,    13,    25,    32,    37,    38,    39,
      51,    67,    92,    93,    98,   167,   169,   100,   172,   173,
     111,   107,   113,     8,    18,    20,    21,    26,    37,    51,
      74,   207,   209,   211,   213,   215,   217,   219,   221,   223,
     227,    32,    53,    96,   241,   248,     8,     9,    13,    32,
      40,    41,    43,    44,    53,    62,    67,    68,    71,    77,
      86,    90,    96,    98,    99,   243,   249,    78,   107,   113,
     115,   254,   256,   257,     6,    25,    50,    74,     6,     8,
      50,    51,    75,    91,    92,    78,   257,    78,   257,    78,
     257,    78,   257,   107,   178,   107,   108,   238,   107,   107,
     107,   145,    16,    36,   101,   148,   149,   107,   126,   127,
     128,   129,   130,     5,   101,   102,   104,   106,   154,   155,
     155,    74,   162,   159,    45,   160,   155,   155,   164,   257,
      61,   107,   257,   107,   168,   107,   257,   257,   107,   107,
     257,    63,   169,   107,   173,   231,   107,   224,   225,   214,
     222,   208,   220,   212,   210,   216,   218,   149,   107,   242,
     107,   248,   257,   257,   107,   107,   244,   107,   257,   107,
      87,    90,   107,   108,   257,   103,   107,   103,   249,   257,
     255,   107,    78,   257,    78,   257,    78,   257,    78,   257,
      78,   257,    78,   257,   257,   257,   257,   257,   140,   107,
     107,   107,   149,     7,   110,   125,   109,   111,   121,   123,
     121,   114,   257,   107,   257,   257,   107,   155,   163,   155,
     155,   161,   155,   155,   107,   113,   121,   114,    55,    55,
      55,    55,    55,    55,    55,    55,   113,   113,    54,   130,
     116,   257,   257,   257,   257,   257,   257,   238,   107,   109,
     122,   107,   127,   107,   129,   155,   155,   225,   225,   124,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   199,   202,   124,   190,   191,   192,   193,   194,   195,
     196,   199,   206,   124,   199,   200,   190,   191,   192,   193,
     194,   195,   196,   199,   205,   124,   190,   191,   199,   201,
     201,   190,   191,   192,   193,   194,   195,   196,   199,   203,
     124,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   204,   225,   225,   114,   122,   114,     8,    31,    37,
      75,    92,    12,    24,    45,    80,    81,    82,   182,   183,
      51,   183,   182,   182,   182,   182,   182,    74,   182,   114,
     114,    78,   257,    78,   257,    78,   257,    78,   257,   107,
     107,   107,   107,    78,   257,    78,   257,   257,   257,   257,
     257,   257,   257
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   117,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   119,   120,   121,   121,   121,   122,   122,
     123,   124,   124,   125,   125,   126,   127,   127,   128,   129,
     129,   130,   130,   132,   131,   133,   135,   134,   136,   137,
     138,   138,   139,   140,   139,   141,   139,   143,   142,   144,
     144,   144,   145,   145,   147,   146,   148,   148,   148,   149,
     149,   150,   150,   150,   150,   151,   152,   152,   152,   152,
     153,   153,   153,   154,   154,   154,   154,   154,   155,   155,
     157,   156,   158,   156,   159,   156,   160,   156,   161,   156,
     162,   156,   163,   156,   164,   156,   165,   156,   166,   156,
     167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
     167,   167,   167,   167,   168,   167,   167,   169,   169,   170,
     171,   171,   172,   173,   173,   175,   174,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   177,   177,
     178,   179,   179,   181,   180,   182,   182,   182,   183,   183,
     183,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   199,   199,
     199,   199,   199,   200,   201,   201,   201,   202,   202,   202,
     202,   202,   202,   203,   203,   203,   203,   203,   203,   203,
     203,   204,   204,   204,   204,   204,   204,   204,   204,   204,
     204,   205,   205,   205,   205,   205,   205,   205,   205,   206,
     206,   206,   206,   206,   206,   206,   206,   208,   207,   210,
     209,   212,   211,   214,   213,   216,   215,   218,   217,   220,
     219,   222,   221,   223,   223,   223,   223,   223,   223,   223,
     223,   224,   225,   225,   226,   227,   226,   228,   226,   229,
     226,   230,   230,   231,   232,   232,   233,   234,   234,   235,
     236,   236,   237,   237,   237,   238,   238,   239,   240,   240,
     241,   242,   241,   241,   241,   243,   243,   243,   243,   243,
     243,   243,   244,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   245,   245,   246,   247,   248,   248,
     249,   249,   251,   250,   252,   253,   252,   254,   255,   254,
     256,   257,   257
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     1,     1,     0,     2,     0,
       2,     1,     0,     1,     1,     3,     1,     3,     1,     1,
       3,     1,     1,     0,     4,     2,     0,     4,     2,     1,
       3,     4,     3,     0,     7,     0,     4,     0,     4,     2,
       2,     2,     2,     0,     0,     5,     2,     2,     2,     2,
       0,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     3,     2,     2,     2,     2,     2,     2,     0,
       0,     3,     0,     3,     0,     4,     0,     4,     0,     5,
       0,     4,     0,     5,     0,     4,     0,     3,     0,     3,
       2,     2,     2,     2,     2,     2,     3,     1,     2,     2,
       1,     2,     2,     2,     0,     5,     1,     2,     0,     2,
       1,     1,     2,     2,     0,     0,     5,     3,     4,     3,
       4,     2,     2,     3,     4,     3,     4,     3,     4,     3,
       3,     3,     4,     5,     3,     4,     5,     3,     4,     5,
       4,     5,     3,     3,     4,     5,     4,     5,     2,     0,
       1,     1,     2,     0,     4,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     3,     4,     3,     4,     3,     4,
       2,     3,     4,     3,     4,     3,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     0,
       5,     0,     5,     0,     5,     0,     5,     0,     5,     0,
       5,     0,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     4,     0,     6,     0,     5,     0,
       7,     1,     1,     1,     3,     1,     2,     2,     0,     2,
       2,     0,     1,     1,     2,     2,     0,     2,     2,     0,
       2,     0,     5,     1,     2,     1,     1,     2,     2,     2,
       2,     2,     0,     5,     1,     2,     1,     1,     2,     2,
       2,     1,     1,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     2,     3,     1,     1,     2,     2,     2,     0,
       2,     0,     0,     4,     3,     0,     6,     1,     0,     4,
       3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 22: /* grammar: grammar error '\n'  */
#line 233 "../../usr.sbin/smtpd/parse.y"
                                                { file->errors++; }
#line 2169 "../../usr.sbin/smtpd/parse.c"
    break;

  case 23: /* include: INCLUDE STRING  */
#line 236 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[0].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));

			file = nfile;
			lungetc('\n');
		}
#line 2187 "../../usr.sbin/smtpd/parse.c"
    break;

  case 24: /* varset: STRING '=' STRING  */
#line 251 "../../usr.sbin/smtpd/parse.y"
                                                {
			char *s = (yyvsp[-2].v.string);
			while (*s++) {
				if (isspace((unsigned char)*s)) {
					yyerror("macro name cannot contain "
					    "whitespace");
					free((yyvsp[-2].v.string));
					free((yyvsp[0].v.string));
					YYERROR;
				}
			}
			if (symset((yyvsp[-2].v.string), (yyvsp[0].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 2208 "../../usr.sbin/smtpd/parse.c"
    break;

  case 31: /* negation: '!'  */
#line 281 "../../usr.sbin/smtpd/parse.y"
                                { (yyval.v.number) = 1; }
#line 2214 "../../usr.sbin/smtpd/parse.c"
    break;

  case 32: /* negation: %empty  */
#line 282 "../../usr.sbin/smtpd/parse.y"
                                { (yyval.v.number) = 0; }
#line 2220 "../../usr.sbin/smtpd/parse.c"
    break;

  case 35: /* keyval: STRING assign STRING  */
#line 288 "../../usr.sbin/smtpd/parse.y"
                                                {
			table_add(table, (yyvsp[-2].v.string), (yyvsp[0].v.string));
			free((yyvsp[-2].v.string));
			free((yyvsp[0].v.string));
		}
#line 2230 "../../usr.sbin/smtpd/parse.c"
    break;

  case 38: /* stringel: STRING  */
#line 299 "../../usr.sbin/smtpd/parse.y"
                                                {
			table_add(table, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
		}
#line 2239 "../../usr.sbin/smtpd/parse.c"
    break;

  case 41: /* tableval_list: string_list  */
#line 309 "../../usr.sbin/smtpd/parse.y"
                                                { }
#line 2245 "../../usr.sbin/smtpd/parse.c"
    break;

  case 42: /* tableval_list: keyval_list  */
#line 310 "../../usr.sbin/smtpd/parse.y"
                                                { }
#line 2251 "../../usr.sbin/smtpd/parse.c"
    break;

  case 43: /* $@1: %empty  */
#line 314 "../../usr.sbin/smtpd/parse.y"
                     {
	memset(conf->sc_bounce_warn, 0, sizeof conf->sc_bounce_warn);
}
#line 2259 "../../usr.sbin/smtpd/parse.c"
    break;

  case 45: /* admd: ADMD STRING  */
#line 321 "../../usr.sbin/smtpd/parse.y"
            {
	size_t i;

	for (i = 0; (yyvsp[0].v.string)[i] != '\0'; i++) {
		if (!isprint((yyvsp[0].v.string)[i])) {
			yyerror("not a valid admd");
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	conf->sc_admd = (yyvsp[0].v.string);
}
#line 2276 "../../usr.sbin/smtpd/parse.c"
    break;

  case 46: /* $@2: %empty  */
#line 336 "../../usr.sbin/smtpd/parse.y"
          {
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp((yyvsp[0].v.string), "*") != 0) {
		if (!res_hnok((yyvsp[0].v.string))) {
			yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
	free((yyvsp[0].v.string));
	sca = dict_get(conf->sc_ca_dict, buf);
	if (sca == NULL) {
		sca = xcalloc(1, sizeof *sca);
		(void)strlcpy(sca->ca_name, buf, sizeof(sca->ca_name));
		dict_set(conf->sc_ca_dict, sca->ca_name, sca);
	}
}
#line 2301 "../../usr.sbin/smtpd/parse.c"
    break;

  case 48: /* ca_params_opt: CERT STRING  */
#line 360 "../../usr.sbin/smtpd/parse.y"
            {
	sca->ca_cert_file = (yyvsp[0].v.string);
}
#line 2309 "../../usr.sbin/smtpd/parse.c"
    break;

  case 51: /* mda: MDA WRAPPER STRING STRING  */
#line 372 "../../usr.sbin/smtpd/parse.y"
                            {
	if (dict_get(conf->sc_mda_wrappers, (yyvsp[-1].v.string))) {
		yyerror("mda wrapper already declared with that name: %s", (yyvsp[-1].v.string));
		YYERROR;
	}
	dict_set(conf->sc_mda_wrappers, (yyvsp[-1].v.string), (yyvsp[0].v.string));
}
#line 2321 "../../usr.sbin/smtpd/parse.c"
    break;

  case 52: /* mta: MTA MAX_DEFERRED NUMBER  */
#line 383 "../../usr.sbin/smtpd/parse.y"
                         {
	conf->sc_mta_max_deferred = (yyvsp[0].v.number);
}
#line 2329 "../../usr.sbin/smtpd/parse.c"
    break;

  case 53: /* $@3: %empty  */
#line 386 "../../usr.sbin/smtpd/parse.y"
                              {
	struct mta_limits	*d;

	limits = dict_get(conf->sc_limits_dict, (yyvsp[0].v.string));
	if (limits == NULL) {
		limits = xcalloc(1, sizeof(*limits));
		dict_xset(conf->sc_limits_dict, (yyvsp[0].v.string), limits);
		d = dict_xget(conf->sc_limits_dict, "default");
		memmove(limits, d, sizeof(*limits));
	}
	free((yyvsp[0].v.string));
}
#line 2346 "../../usr.sbin/smtpd/parse.c"
    break;

  case 55: /* $@4: %empty  */
#line 398 "../../usr.sbin/smtpd/parse.y"
            {
	limits = dict_get(conf->sc_limits_dict, "default");
}
#line 2354 "../../usr.sbin/smtpd/parse.c"
    break;

  case 57: /* $@5: %empty  */
#line 405 "../../usr.sbin/smtpd/parse.y"
           {
	char buf[HOST_NAME_MAX+1];

	/* if not catchall, check that it is a valid domain */
	if (strcmp((yyvsp[0].v.string), "*") != 0) {
		if (!res_hnok((yyvsp[0].v.string))) {
			yyerror("not a valid domain name: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}
	xlowercase(buf, (yyvsp[0].v.string), sizeof(buf));
	free((yyvsp[0].v.string));
	pki = dict_get(conf->sc_pki_dict, buf);
	if (pki == NULL) {
		pki = xcalloc(1, sizeof *pki);
		(void)strlcpy(pki->pki_name, buf, sizeof(pki->pki_name));
		dict_set(conf->sc_pki_dict, pki->pki_name, pki);
	}
}
#line 2379 "../../usr.sbin/smtpd/parse.c"
    break;

  case 59: /* pki_params_opt: CERT STRING  */
#line 428 "../../usr.sbin/smtpd/parse.y"
            {
	pki->pki_cert_file = (yyvsp[0].v.string);
}
#line 2387 "../../usr.sbin/smtpd/parse.c"
    break;

  case 60: /* pki_params_opt: KEY STRING  */
#line 431 "../../usr.sbin/smtpd/parse.y"
             {
	pki->pki_key_file = (yyvsp[0].v.string);
}
#line 2395 "../../usr.sbin/smtpd/parse.c"
    break;

  case 61: /* pki_params_opt: DHE STRING  */
#line 434 "../../usr.sbin/smtpd/parse.y"
             {
	if (strcasecmp((yyvsp[0].v.string), "none") == 0)
		pki->pki_dhe = 0;
	else if (strcasecmp((yyvsp[0].v.string), "auto") == 0)
		pki->pki_dhe = 1;
	else if (strcasecmp((yyvsp[0].v.string), "legacy") == 0)
		pki->pki_dhe = 2;
	else {
		yyerror("invalid DHE keyword: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2414 "../../usr.sbin/smtpd/parse.c"
    break;

  case 64: /* $@6: %empty  */
#line 458 "../../usr.sbin/smtpd/parse.y"
                   {
	if (dict_get(conf->sc_filter_processes_dict, (yyvsp[-1].v.string))) {
		yyerror("processor already exists with that name: %s", (yyvsp[-1].v.string));
		free((yyvsp[-1].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor = xcalloc(1, sizeof *processor);
	processor->command = (yyvsp[0].v.string);
}
#line 2429 "../../usr.sbin/smtpd/parse.c"
    break;

  case 65: /* proc: PROC STRING STRING $@6 proc_params  */
#line 467 "../../usr.sbin/smtpd/parse.y"
              {
	dict_set(conf->sc_filter_processes_dict, (yyvsp[-3].v.string), processor);
	processor = NULL;
}
#line 2438 "../../usr.sbin/smtpd/parse.c"
    break;

  case 66: /* proc_params_opt: USER STRING  */
#line 475 "../../usr.sbin/smtpd/parse.y"
            {
	if (processor->user) {
		yyerror("user already specified for this processor");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor->user = (yyvsp[0].v.string);
}
#line 2451 "../../usr.sbin/smtpd/parse.c"
    break;

  case 67: /* proc_params_opt: GROUP STRING  */
#line 483 "../../usr.sbin/smtpd/parse.y"
               {
	if (processor->group) {
		yyerror("group already specified for this processor");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor->group = (yyvsp[0].v.string);
}
#line 2464 "../../usr.sbin/smtpd/parse.c"
    break;

  case 68: /* proc_params_opt: CHROOT STRING  */
#line 491 "../../usr.sbin/smtpd/parse.y"
                {
	if (processor->chroot) {
		yyerror("chroot already specified for this processor");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	processor->chroot = (yyvsp[0].v.string);
}
#line 2477 "../../usr.sbin/smtpd/parse.c"
    break;

  case 71: /* queue: QUEUE COMPRESSION  */
#line 508 "../../usr.sbin/smtpd/parse.y"
                  {
	conf->sc_queue_flags |= QUEUE_COMPRESSION;
}
#line 2485 "../../usr.sbin/smtpd/parse.c"
    break;

  case 72: /* queue: QUEUE ENCRYPTION  */
#line 511 "../../usr.sbin/smtpd/parse.y"
                   {
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
#line 2493 "../../usr.sbin/smtpd/parse.c"
    break;

  case 73: /* queue: QUEUE ENCRYPTION STRING  */
#line 514 "../../usr.sbin/smtpd/parse.y"
                          {
	if (strcasecmp((yyvsp[0].v.string), "stdin") == 0 || strcasecmp((yyvsp[0].v.string), "-") == 0) {
		conf->sc_queue_key = "stdin";
		free((yyvsp[0].v.string));
	}
	else
		conf->sc_queue_key = (yyvsp[0].v.string);
	conf->sc_queue_flags |= QUEUE_ENCRYPTION;
}
#line 2507 "../../usr.sbin/smtpd/parse.c"
    break;

  case 74: /* queue: QUEUE TTL STRING  */
#line 523 "../../usr.sbin/smtpd/parse.y"
                   {
	conf->sc_ttl = delaytonum((yyvsp[0].v.string));
	if (conf->sc_ttl == -1) {
		yyerror("invalid ttl delay: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2521 "../../usr.sbin/smtpd/parse.c"
    break;

  case 77: /* smtp: SMTP CIPHERS STRING  */
#line 542 "../../usr.sbin/smtpd/parse.y"
                      {
	conf->sc_tls_ciphers = (yyvsp[0].v.string);
}
#line 2529 "../../usr.sbin/smtpd/parse.c"
    break;

  case 78: /* smtp: SMTP MAX_MESSAGE_SIZE size  */
#line 545 "../../usr.sbin/smtpd/parse.y"
                             {
	conf->sc_maxsize = (yyvsp[0].v.number);
}
#line 2537 "../../usr.sbin/smtpd/parse.c"
    break;

  case 79: /* smtp: SMTP SUB_ADDR_DELIM STRING  */
#line 548 "../../usr.sbin/smtpd/parse.y"
                             {
	if (strlen((yyvsp[0].v.string)) != 1) {
		yyerror("subaddressing-delimiter must be one character");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if (isspace((unsigned char)*(yyvsp[0].v.string)) || !isprint((unsigned char)*(yyvsp[0].v.string)) || *(yyvsp[0].v.string) == '@') {
		yyerror("sub-addr-delim uses invalid character");
		free((yyvsp[0].v.string));
		YYERROR;
	}
	conf->sc_subaddressing_delim = (yyvsp[0].v.string);
}
#line 2555 "../../usr.sbin/smtpd/parse.c"
    break;

  case 80: /* srs: SRS KEY STRING  */
#line 564 "../../usr.sbin/smtpd/parse.y"
               {
	conf->sc_srs_key = (yyvsp[0].v.string);
}
#line 2563 "../../usr.sbin/smtpd/parse.c"
    break;

  case 81: /* srs: SRS KEY BACKUP STRING  */
#line 567 "../../usr.sbin/smtpd/parse.y"
                        {
	conf->sc_srs_key_backup = (yyvsp[0].v.string);
}
#line 2571 "../../usr.sbin/smtpd/parse.c"
    break;

  case 82: /* srs: SRS TTL STRING  */
#line 570 "../../usr.sbin/smtpd/parse.y"
                 {
	conf->sc_srs_ttl = delaytonum((yyvsp[0].v.string));
	if (conf->sc_srs_ttl == -1) {
		yyerror("ttl delay \"%s\" is invalid", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	conf->sc_srs_ttl /= 86400;
	if (conf->sc_srs_ttl == 0) {
		yyerror("ttl delay \"%s\" is too short", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 2592 "../../usr.sbin/smtpd/parse.c"
    break;

  case 83: /* dispatcher_local_option: USER STRING  */
#line 590 "../../usr.sbin/smtpd/parse.y"
            {
	if (dispatcher->u.local.is_mbox) {
		yyerror("user may not be specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.forward_only) {
		yyerror("user may not be specified for forward-only");
		YYERROR;
	}

	if (dispatcher->u.local.expand_only) {
		yyerror("user may not be specified for expand-only");
		YYERROR;
	}

	if (dispatcher->u.local.user) {
		yyerror("user already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.local.user = (yyvsp[0].v.string);
}
#line 2620 "../../usr.sbin/smtpd/parse.c"
    break;

  case 84: /* dispatcher_local_option: ALIAS tables  */
#line 613 "../../usr.sbin/smtpd/parse.y"
               {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for alias lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_alias = strdup(t->t_name);
}
#line 2646 "../../usr.sbin/smtpd/parse.c"
    break;

  case 85: /* dispatcher_local_option: VIRTUAL tables  */
#line 634 "../../usr.sbin/smtpd/parse.y"
                 {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_virtual) {
		yyerror("virtual mapping already specified for this dispatcher");
		YYERROR;
	}

	if (dispatcher->u.local.table_alias) {
		yyerror("alias mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
		yyerror("table \"%s\" may not be used for virtual lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_virtual = strdup(t->t_name);
}
#line 2672 "../../usr.sbin/smtpd/parse.c"
    break;

  case 86: /* dispatcher_local_option: USERBASE tables  */
#line 655 "../../usr.sbin/smtpd/parse.y"
                  {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.local.table_userbase) {
		yyerror("userbase mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
		yyerror("table \"%s\" may not be used for userbase lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.local.table_userbase = strdup(t->t_name);
}
#line 2693 "../../usr.sbin/smtpd/parse.c"
    break;

  case 87: /* dispatcher_local_option: WRAPPER STRING  */
#line 671 "../../usr.sbin/smtpd/parse.y"
                 {
	if (! dict_get(conf->sc_mda_wrappers, (yyvsp[0].v.string))) {
		yyerror("no mda wrapper with that name: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	dispatcher->u.local.mda_wrapper = (yyvsp[0].v.string);
}
#line 2705 "../../usr.sbin/smtpd/parse.c"
    break;

  case 90: /* $@7: %empty  */
#line 686 "../../usr.sbin/smtpd/parse.y"
     {
	dispatcher->u.local.is_mbox = 1;
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.local -f %%{mbox.from} -- %%{user.username}");
}
#line 2714 "../../usr.sbin/smtpd/parse.c"
    break;

  case 92: /* $@8: %empty  */
#line 690 "../../usr.sbin/smtpd/parse.y"
          {
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.maildir");
}
#line 2722 "../../usr.sbin/smtpd/parse.c"
    break;

  case 94: /* $@9: %empty  */
#line 693 "../../usr.sbin/smtpd/parse.y"
               {
	asprintf(&dispatcher->u.local.command, PATH_LIBEXEC"/mail.maildir -j");
}
#line 2730 "../../usr.sbin/smtpd/parse.c"
    break;

  case 96: /* $@10: %empty  */
#line 696 "../../usr.sbin/smtpd/parse.y"
                 {
	if (strncmp((yyvsp[0].v.string), "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir \"%%{user.directory}/%s\"", (yyvsp[0].v.string)+2);
	else
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir \"%s\"", (yyvsp[0].v.string));
}
#line 2743 "../../usr.sbin/smtpd/parse.c"
    break;

  case 98: /* $@11: %empty  */
#line 704 "../../usr.sbin/smtpd/parse.y"
                      {
	if (strncmp((yyvsp[-1].v.string), "~/", 2) == 0)
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir -j \"%%{user.directory}/%s\"", (yyvsp[-1].v.string)+2);
	else
		asprintf(&dispatcher->u.local.command,
		    PATH_LIBEXEC"/mail.maildir -j \"%s\"", (yyvsp[-1].v.string));
}
#line 2756 "../../usr.sbin/smtpd/parse.c"
    break;

  case 100: /* $@12: %empty  */
#line 712 "../../usr.sbin/smtpd/parse.y"
              {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.lmtp -d \"%s\" -u", (yyvsp[0].v.string));
}
#line 2765 "../../usr.sbin/smtpd/parse.c"
    break;

  case 102: /* $@13: %empty  */
#line 716 "../../usr.sbin/smtpd/parse.y"
                      {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.lmtp -d \"%s\" -r", (yyvsp[-1].v.string));
}
#line 2774 "../../usr.sbin/smtpd/parse.c"
    break;

  case 104: /* $@14: %empty  */
#line 720 "../../usr.sbin/smtpd/parse.y"
             {
	asprintf(&dispatcher->u.local.command,
	    PATH_LIBEXEC"/mail.mda \"%s\"", (yyvsp[0].v.string));
}
#line 2783 "../../usr.sbin/smtpd/parse.c"
    break;

  case 106: /* $@15: %empty  */
#line 724 "../../usr.sbin/smtpd/parse.y"
               {
	dispatcher->u.local.forward_only = 1;
}
#line 2791 "../../usr.sbin/smtpd/parse.c"
    break;

  case 108: /* $@16: %empty  */
#line 727 "../../usr.sbin/smtpd/parse.y"
              {
	dispatcher->u.local.expand_only = 1;
}
#line 2799 "../../usr.sbin/smtpd/parse.c"
    break;

  case 110: /* dispatcher_remote_option: HELO STRING  */
#line 734 "../../usr.sbin/smtpd/parse.y"
            {
	if (dispatcher->u.remote.helo) {
		yyerror("helo already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.helo = (yyvsp[0].v.string);
}
#line 2812 "../../usr.sbin/smtpd/parse.c"
    break;

  case 111: /* dispatcher_remote_option: HELO_SRC tables  */
#line 742 "../../usr.sbin/smtpd/parse.y"
                  {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.helo_source) {
		yyerror("helo-source mapping already specified for this dispatcher");
		YYERROR;
	}
	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
		yyerror("table \"%s\" may not be used for helo-source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.helo_source = strdup(t->t_name);
}
#line 2832 "../../usr.sbin/smtpd/parse.c"
    break;

  case 112: /* dispatcher_remote_option: PKI STRING  */
#line 757 "../../usr.sbin/smtpd/parse.y"
             {
	if (dispatcher->u.remote.pki) {
		yyerror("pki already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.pki = (yyvsp[0].v.string);
}
#line 2845 "../../usr.sbin/smtpd/parse.c"
    break;

  case 113: /* dispatcher_remote_option: CA STRING  */
#line 765 "../../usr.sbin/smtpd/parse.y"
            {
	if (dispatcher->u.remote.ca) {
		yyerror("ca already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.ca = (yyvsp[0].v.string);
}
#line 2858 "../../usr.sbin/smtpd/parse.c"
    break;

  case 114: /* dispatcher_remote_option: SRC tables  */
#line 773 "../../usr.sbin/smtpd/parse.y"
             {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.source) {
		yyerror("source mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
		yyerror("table \"%s\" may not be used for source lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.source = strdup(t->t_name);
}
#line 2879 "../../usr.sbin/smtpd/parse.c"
    break;

  case 115: /* dispatcher_remote_option: MAIL_FROM STRING  */
#line 789 "../../usr.sbin/smtpd/parse.y"
                   {
	if (dispatcher->u.remote.mail_from) {
		yyerror("mail-from already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.mail_from = (yyvsp[0].v.string);
}
#line 2892 "../../usr.sbin/smtpd/parse.c"
    break;

  case 116: /* dispatcher_remote_option: BACKUP MX STRING  */
#line 797 "../../usr.sbin/smtpd/parse.y"
                   {
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
	dispatcher->u.remote.backupmx = (yyvsp[0].v.string);
}
#line 2910 "../../usr.sbin/smtpd/parse.c"
    break;

  case 117: /* dispatcher_remote_option: BACKUP  */
#line 810 "../../usr.sbin/smtpd/parse.y"
         {
	if (dispatcher->u.remote.backup) {
		yyerror("backup already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.smarthost) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	dispatcher->u.remote.backup = 1;
}
#line 2927 "../../usr.sbin/smtpd/parse.c"
    break;

  case 118: /* dispatcher_remote_option: HOST tables  */
#line 822 "../../usr.sbin/smtpd/parse.y"
              {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost) {
		yyerror("host mapping already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.backup) {
		yyerror("backup and host are mutually exclusive");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_RELAYHOST)) {
		yyerror("table \"%s\" may not be used for host lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.smarthost = strdup(t->t_name);
}
#line 2952 "../../usr.sbin/smtpd/parse.c"
    break;

  case 119: /* dispatcher_remote_option: DOMAIN tables  */
#line 842 "../../usr.sbin/smtpd/parse.y"
                {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost) {
		yyerror("host mapping already specified for this dispatcher");
		YYERROR;
	}
	if (dispatcher->u.remote.backup) {
		yyerror("backup and domain are mutually exclusive");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_RELAYHOST)) {
		yyerror("table \"%s\" may not be used for host lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.smarthost = strdup(t->t_name);
	dispatcher->u.remote.smarthost_domain = 1;
}
#line 2978 "../../usr.sbin/smtpd/parse.c"
    break;

  case 120: /* dispatcher_remote_option: TLS  */
#line 863 "../../usr.sbin/smtpd/parse.y"
      {
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
}
#line 2991 "../../usr.sbin/smtpd/parse.c"
    break;

  case 121: /* dispatcher_remote_option: TLS NO_VERIFY  */
#line 871 "../../usr.sbin/smtpd/parse.y"
                {
	if (dispatcher->u.remote.tls_required == 1) {
		yyerror("tls already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.tls_required = 1;
	dispatcher->u.remote.tls_noverify = 1;
}
#line 3005 "../../usr.sbin/smtpd/parse.c"
    break;

  case 122: /* dispatcher_remote_option: AUTH tables  */
#line 880 "../../usr.sbin/smtpd/parse.y"
              {
	struct table   *t = (yyvsp[0].v.table);

	if (dispatcher->u.remote.smarthost == NULL) {
		yyerror("auth may not be specified without host on a dispatcher");
		YYERROR;
	}

	if (dispatcher->u.remote.auth) {
		yyerror("auth mapping already specified for this dispatcher");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	dispatcher->u.remote.auth = strdup(t->t_name);
}
#line 3031 "../../usr.sbin/smtpd/parse.c"
    break;

  case 123: /* dispatcher_remote_option: FILTER STRING  */
#line 901 "../../usr.sbin/smtpd/parse.y"
                {
	struct filter_config *fc;

	if (dispatcher->u.remote.filtername) {
		yyerror("filter already specified for this dispatcher");
		YYERROR;
	}

	if ((fc = dict_get(conf->sc_filters_dict, (yyvsp[0].v.string))) == NULL) {
		yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	fc->filter_subsystem |= FILTER_SUBSYSTEM_SMTP_OUT;
	dispatcher->u.remote.filtername = (yyvsp[0].v.string);
}
#line 3052 "../../usr.sbin/smtpd/parse.c"
    break;

  case 124: /* $@17: %empty  */
#line 917 "../../usr.sbin/smtpd/parse.y"
         {
	char	buffer[128];
	char	*filtername;

	if (dispatcher->u.remote.filtername) {
		yyerror("filter already specified for this dispatcher");
		YYERROR;
	}

	do {
		(void)snprintf(buffer, sizeof buffer, "<dynchain:%08x>", last_dynchain_id++);
	} while (dict_check(conf->sc_filters_dict, buffer));

	filtername = xstrdup(buffer);
	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_CHAIN;
	filter_config->filter_subsystem |= FILTER_SUBSYSTEM_SMTP_OUT;
	dict_init(&filter_config->chain_procs);
	dispatcher->u.remote.filtername = filtername;
}
#line 3077 "../../usr.sbin/smtpd/parse.c"
    break;

  case 125: /* dispatcher_remote_option: FILTER $@17 '{' filter_list '}'  */
#line 936 "../../usr.sbin/smtpd/parse.y"
                      {
	dict_set(conf->sc_filters_dict, dispatcher->u.remote.filtername, filter_config);
	filter_config = NULL;
}
#line 3086 "../../usr.sbin/smtpd/parse.c"
    break;

  case 126: /* dispatcher_remote_option: SRS  */
#line 940 "../../usr.sbin/smtpd/parse.y"
      {
	if (conf->sc_srs_key == NULL) {
		yyerror("an srs key is required for srs to be specified in an action");
		YYERROR;
	}
	if (dispatcher->u.remote.srs == 1) {
		yyerror("srs already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->u.remote.srs = 1;
}
#line 3103 "../../usr.sbin/smtpd/parse.c"
    break;

  case 130: /* dispatcher_type: dispatcher_local  */
#line 964 "../../usr.sbin/smtpd/parse.y"
                 {
	dispatcher->type = DISPATCHER_LOCAL;
}
#line 3111 "../../usr.sbin/smtpd/parse.c"
    break;

  case 131: /* dispatcher_type: dispatcher_remote  */
#line 967 "../../usr.sbin/smtpd/parse.y"
                    {
	dispatcher->type = DISPATCHER_REMOTE;
}
#line 3119 "../../usr.sbin/smtpd/parse.c"
    break;

  case 132: /* dispatcher_option: TTL STRING  */
#line 973 "../../usr.sbin/smtpd/parse.y"
           {
	if (dispatcher->ttl) {
		yyerror("ttl already specified for this dispatcher");
		YYERROR;
	}

	dispatcher->ttl = delaytonum((yyvsp[0].v.string));
	if (dispatcher->ttl == -1) {
		yyerror("ttl delay \"%s\" is invalid", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	free((yyvsp[0].v.string));
}
#line 3138 "../../usr.sbin/smtpd/parse.c"
    break;

  case 135: /* $@18: %empty  */
#line 995 "../../usr.sbin/smtpd/parse.y"
              {
	if (dict_get(conf->sc_dispatchers, (yyvsp[0].v.string))) {
		yyerror("dispatcher already declared with that name: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	dispatcher = xcalloc(1, sizeof *dispatcher);
}
#line 3150 "../../usr.sbin/smtpd/parse.c"
    break;

  case 136: /* dispatcher: ACTION STRING $@18 dispatcher_type dispatcher_options  */
#line 1001 "../../usr.sbin/smtpd/parse.y"
                                     {
	if (dispatcher->type == DISPATCHER_LOCAL)
		if (dispatcher->u.local.table_userbase == NULL)
			dispatcher->u.local.table_userbase = "<getpwnam>";
	dict_set(conf->sc_dispatchers, (yyvsp[-3].v.string), dispatcher);
	dispatcher = NULL;
}
#line 3162 "../../usr.sbin/smtpd/parse.c"
    break;

  case 137: /* match_option: negation TAG tables  */
#line 1011 "../../usr.sbin/smtpd/parse.y"
                    {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_tag) {
		yyerror("tag already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_STRING)) {
		yyerror("table \"%s\" may not be used for tag lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_tag = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_tag = strdup(t->t_name);
}
#line 3184 "../../usr.sbin/smtpd/parse.c"
    break;

  case 138: /* match_option: negation TAG REGEX tables  */
#line 1029 "../../usr.sbin/smtpd/parse.y"
                          {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_tag) {
		yyerror("tag already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for tag lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_tag = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_tag_regex = 1;
	rule->table_tag = strdup(t->t_name);
}
#line 3207 "../../usr.sbin/smtpd/parse.c"
    break;

  case 139: /* match_option: negation HELO tables  */
#line 1048 "../../usr.sbin/smtpd/parse.y"
                       {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_helo) {
		yyerror("helo already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for helo lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_helo = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_helo = strdup(t->t_name);
}
#line 3229 "../../usr.sbin/smtpd/parse.c"
    break;

  case 140: /* match_option: negation HELO REGEX tables  */
#line 1065 "../../usr.sbin/smtpd/parse.y"
                             {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_helo) {
		yyerror("helo already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for helo lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_helo = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_helo_regex = 1;
	rule->table_smtp_helo = strdup(t->t_name);
}
#line 3252 "../../usr.sbin/smtpd/parse.c"
    break;

  case 141: /* match_option: negation TLS  */
#line 1083 "../../usr.sbin/smtpd/parse.y"
               {
	if (rule->flag_smtp_starttls) {
		yyerror("tls already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_starttls = (yyvsp[-1].v.number) ? -1 : 1;
}
#line 3264 "../../usr.sbin/smtpd/parse.c"
    break;

  case 142: /* match_option: negation AUTH  */
#line 1090 "../../usr.sbin/smtpd/parse.y"
                {
	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}
	rule->flag_smtp_auth = (yyvsp[-1].v.number) ? -1 : 1;
}
#line 3276 "../../usr.sbin/smtpd/parse.c"
    break;

  case 143: /* match_option: negation AUTH tables  */
#line 1097 "../../usr.sbin/smtpd/parse.y"
                       {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}

       	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_STRING|K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_auth = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 3298 "../../usr.sbin/smtpd/parse.c"
    break;

  case 144: /* match_option: negation AUTH REGEX tables  */
#line 1114 "../../usr.sbin/smtpd/parse.y"
                             {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_auth) {
		yyerror("auth already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for auth lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_auth = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_auth_regex = 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 3321 "../../usr.sbin/smtpd/parse.c"
    break;

  case 145: /* match_option: negation MAIL_FROM tables  */
#line 1132 "../../usr.sbin/smtpd/parse.y"
                            {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_mail_from) {
		yyerror("mail-from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for mail-from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_mail_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 3343 "../../usr.sbin/smtpd/parse.c"
    break;

  case 146: /* match_option: negation MAIL_FROM REGEX tables  */
#line 1149 "../../usr.sbin/smtpd/parse.y"
                                  {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_mail_from) {
		yyerror("mail-from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for mail-from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_mail_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_mail_from_regex = 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 3366 "../../usr.sbin/smtpd/parse.c"
    break;

  case 147: /* match_option: negation RCPT_TO tables  */
#line 1167 "../../usr.sbin/smtpd/parse.y"
                          {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_rcpt_to) {
		yyerror("rcpt-to already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for rcpt-to lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_rcpt_to = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 3388 "../../usr.sbin/smtpd/parse.c"
    break;

  case 148: /* match_option: negation RCPT_TO REGEX tables  */
#line 1184 "../../usr.sbin/smtpd/parse.y"
                                {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_smtp_rcpt_to) {
		yyerror("rcpt-to already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for rcpt-to lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_smtp_rcpt_to = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_smtp_rcpt_to_regex = 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 3411 "../../usr.sbin/smtpd/parse.c"
    break;

  case 149: /* match_option: negation FROM SOCKET  */
#line 1203 "../../usr.sbin/smtpd/parse.y"
                       {
	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->flag_from_socket = 1;
}
#line 3424 "../../usr.sbin/smtpd/parse.c"
    break;

  case 150: /* match_option: negation FROM LOCAL  */
#line 1211 "../../usr.sbin/smtpd/parse.y"
                      {
	struct table	*t = table_find(conf, "<localhost>");

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 3439 "../../usr.sbin/smtpd/parse.c"
    break;

  case 151: /* match_option: negation FROM ANY  */
#line 1221 "../../usr.sbin/smtpd/parse.y"
                    {
	struct table	*t = table_find(conf, "<anyhost>");

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 3454 "../../usr.sbin/smtpd/parse.c"
    break;

  case 152: /* match_option: negation FROM SRC tables  */
#line 1231 "../../usr.sbin/smtpd/parse.y"
                           {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_from = strdup(t->t_name);
}
#line 3476 "../../usr.sbin/smtpd/parse.c"
    break;

  case 153: /* match_option: negation FROM SRC REGEX tables  */
#line 1248 "../../usr.sbin/smtpd/parse.y"
                                 {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_from_regex = 1;
	rule->table_from = strdup(t->t_name);
}
#line 3499 "../../usr.sbin/smtpd/parse.c"
    break;

  case 154: /* match_option: negation FROM RDNS  */
#line 1266 "../../usr.sbin/smtpd/parse.y"
                     {
	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}
	rule->flag_from = (yyvsp[-2].v.number) ? -1 : 1;
	rule->flag_from_rdns = 1;
}
#line 3512 "../../usr.sbin/smtpd/parse.c"
    break;

  case 155: /* match_option: negation FROM RDNS tables  */
#line 1274 "../../usr.sbin/smtpd/parse.y"
                            {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for rdns lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->flag_from_rdns = 1;
	rule->table_from = strdup(t->t_name);
}
#line 3535 "../../usr.sbin/smtpd/parse.c"
    break;

  case 156: /* match_option: negation FROM RDNS REGEX tables  */
#line 1292 "../../usr.sbin/smtpd/parse.y"
                                  {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for rdns lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_from_regex = 1;
	rule->flag_from_rdns = 1;
	rule->table_from = strdup(t->t_name);
}
#line 3559 "../../usr.sbin/smtpd/parse.c"
    break;

  case 157: /* match_option: negation FROM AUTH  */
#line 1312 "../../usr.sbin/smtpd/parse.y"
                     {
	struct table	*anyhost = table_find(conf, "<anyhost>");

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	rule->flag_from = 1;
	rule->table_from = strdup(anyhost->t_name);
	rule->flag_smtp_auth = (yyvsp[-2].v.number) ? -1 : 1;
}
#line 3576 "../../usr.sbin/smtpd/parse.c"
    break;

  case 158: /* match_option: negation FROM AUTH tables  */
#line 1324 "../../usr.sbin/smtpd/parse.y"
                            {
	struct table	*anyhost = table_find(conf, "<anyhost>");
	struct table	*t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

       	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_STRING|K_CREDENTIALS)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = 1;
	rule->table_from = strdup(anyhost->t_name);
	rule->flag_smtp_auth = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 3601 "../../usr.sbin/smtpd/parse.c"
    break;

  case 159: /* match_option: negation FROM AUTH REGEX tables  */
#line 1344 "../../usr.sbin/smtpd/parse.y"
                                  {
	struct table	*anyhost = table_find(conf, "<anyhost>");
	struct table	*t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
        	yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = 1;
	rule->table_from = strdup(anyhost->t_name);
	rule->flag_smtp_auth = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_smtp_auth_regex = 1;
	rule->table_smtp_auth = strdup(t->t_name);
}
#line 3627 "../../usr.sbin/smtpd/parse.c"
    break;

  case 160: /* match_option: negation FROM MAIL_FROM tables  */
#line 1366 "../../usr.sbin/smtpd/parse.y"
                                 {
	struct table	*anyhost = table_find(conf, "<anyhost>");
	struct table	*t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = 1;
	rule->table_from = strdup(anyhost->t_name);
	rule->flag_smtp_mail_from = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 3652 "../../usr.sbin/smtpd/parse.c"
    break;

  case 161: /* match_option: negation FROM MAIL_FROM REGEX tables  */
#line 1386 "../../usr.sbin/smtpd/parse.y"
                                       {
	struct table	*anyhost = table_find(conf, "<anyhost>");
	struct table	*t = (yyvsp[0].v.table);

	if (rule->flag_from) {
		yyerror("from already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for from lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_from = 1;
	rule->table_from = strdup(anyhost->t_name);
	rule->flag_smtp_mail_from = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_smtp_mail_from_regex = 1;
	rule->table_smtp_mail_from = strdup(t->t_name);
}
#line 3678 "../../usr.sbin/smtpd/parse.c"
    break;

  case 162: /* match_option: negation FOR LOCAL  */
#line 1408 "../../usr.sbin/smtpd/parse.y"
                     {
	struct table   *t = table_find(conf, "<localnames>");

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 3693 "../../usr.sbin/smtpd/parse.c"
    break;

  case 163: /* match_option: negation FOR ANY  */
#line 1418 "../../usr.sbin/smtpd/parse.y"
                   {
	struct table   *t = table_find(conf, "<anydestination>");

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}
	rule->flag_for = (yyvsp[-2].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 3708 "../../usr.sbin/smtpd/parse.c"
    break;

  case 164: /* match_option: negation FOR DOMAIN tables  */
#line 1428 "../../usr.sbin/smtpd/parse.y"
                             {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
		yyerror("table \"%s\" may not be used for 'for' lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_for = strdup(t->t_name);
}
#line 3730 "../../usr.sbin/smtpd/parse.c"
    break;

  case 165: /* match_option: negation FOR DOMAIN REGEX tables  */
#line 1445 "../../usr.sbin/smtpd/parse.y"
                                   {
	struct table   *t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for 'for' lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_for_regex = 1;
	rule->table_for = strdup(t->t_name);
}
#line 3753 "../../usr.sbin/smtpd/parse.c"
    break;

  case 166: /* match_option: negation FOR RCPT_TO tables  */
#line 1463 "../../usr.sbin/smtpd/parse.y"
                              {
	struct table	*anyhost = table_find(conf, "<anydestination>");
	struct table	*t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
		yyerror("table \"%s\" may not be used for for lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = 1;
	rule->table_for = strdup(anyhost->t_name);
	rule->flag_smtp_rcpt_to = (yyvsp[-3].v.number) ? -1 : 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 3778 "../../usr.sbin/smtpd/parse.c"
    break;

  case 167: /* match_option: negation FOR RCPT_TO REGEX tables  */
#line 1483 "../../usr.sbin/smtpd/parse.y"
                                    {
	struct table	*anyhost = table_find(conf, "<anydestination>");
	struct table	*t = (yyvsp[0].v.table);

	if (rule->flag_for) {
		yyerror("for already specified for this rule");
		YYERROR;
	}

	if (!table_check_use(t, T_DYNAMIC|T_LIST, K_REGEX)) {
		yyerror("table \"%s\" may not be used for for lookups",
		    t->t_name);
		YYERROR;
	}

	rule->flag_for = 1;
	rule->table_for = strdup(anyhost->t_name);
	rule->flag_smtp_rcpt_to = (yyvsp[-4].v.number) ? -1 : 1;
	rule->flag_smtp_rcpt_to_regex = 1;
	rule->table_smtp_rcpt_to = strdup(t->t_name);
}
#line 3804 "../../usr.sbin/smtpd/parse.c"
    break;

  case 170: /* match_dispatcher: STRING  */
#line 1512 "../../usr.sbin/smtpd/parse.y"
       {
	if (dict_get(conf->sc_dispatchers, (yyvsp[0].v.string)) == NULL) {
		yyerror("no such dispatcher: %s", (yyvsp[0].v.string));
		YYERROR;
	}
	rule->dispatcher = (yyvsp[0].v.string);
}
#line 3816 "../../usr.sbin/smtpd/parse.c"
    break;

  case 171: /* action: REJECT  */
#line 1522 "../../usr.sbin/smtpd/parse.y"
       {
	rule->reject = 1;
}
#line 3824 "../../usr.sbin/smtpd/parse.c"
    break;

  case 173: /* $@19: %empty  */
#line 1529 "../../usr.sbin/smtpd/parse.y"
      {
	rule = xcalloc(1, sizeof *rule);
}
#line 3832 "../../usr.sbin/smtpd/parse.c"
    break;

  case 174: /* match: MATCH $@19 match_options action  */
#line 1531 "../../usr.sbin/smtpd/parse.y"
                       {
	if (!rule->flag_from) {
		rule->table_from = strdup("<localhost>");
		rule->flag_from = 1;
	}
	if (!rule->flag_for) {
		rule->table_for = strdup("<localnames>");
		rule->flag_for = 1;
	}
	TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
	rule = NULL;
}
#line 3849 "../../usr.sbin/smtpd/parse.c"
    break;

  case 176: /* filter_action_builtin: JUNK  */
#line 1547 "../../usr.sbin/smtpd/parse.y"
       {
	filter_config->junk = 1;
}
#line 3857 "../../usr.sbin/smtpd/parse.c"
    break;

  case 177: /* filter_action_builtin: BYPASS  */
#line 1550 "../../usr.sbin/smtpd/parse.y"
         {
	filter_config->bypass = 1;
}
#line 3865 "../../usr.sbin/smtpd/parse.c"
    break;

  case 178: /* filter_action_builtin_nojunk: REJECT STRING  */
#line 1556 "../../usr.sbin/smtpd/parse.y"
              {
	filter_config->reject = (yyvsp[0].v.string);
}
#line 3873 "../../usr.sbin/smtpd/parse.c"
    break;

  case 179: /* filter_action_builtin_nojunk: DISCONNECT STRING  */
#line 1559 "../../usr.sbin/smtpd/parse.y"
                    {
	filter_config->disconnect = (yyvsp[0].v.string);
}
#line 3881 "../../usr.sbin/smtpd/parse.c"
    break;

  case 180: /* filter_action_builtin_nojunk: REWRITE STRING  */
#line 1562 "../../usr.sbin/smtpd/parse.y"
                 {
	filter_config->rewrite = (yyvsp[0].v.string);
}
#line 3889 "../../usr.sbin/smtpd/parse.c"
    break;

  case 181: /* filter_action_builtin_nojunk: REPORT STRING  */
#line 1565 "../../usr.sbin/smtpd/parse.y"
                {
	filter_config->report = (yyvsp[0].v.string);
}
#line 3897 "../../usr.sbin/smtpd/parse.c"
    break;

  case 182: /* filter_phase_check_fcrdns: negation FCRDNS  */
#line 1571 "../../usr.sbin/smtpd/parse.y"
                {
	filter_config->not_fcrdns = (yyvsp[-1].v.number) ? -1 : 1;
	filter_config->fcrdns = 1;
}
#line 3906 "../../usr.sbin/smtpd/parse.c"
    break;

  case 183: /* filter_phase_check_rdns: negation RDNS  */
#line 1578 "../../usr.sbin/smtpd/parse.y"
              {
	filter_config->not_rdns = (yyvsp[-1].v.number) ? -1 : 1;
	filter_config->rdns = 1;
}
#line 3915 "../../usr.sbin/smtpd/parse.c"
    break;

  case 184: /* filter_phase_check_rdns_table: negation RDNS tables  */
#line 1585 "../../usr.sbin/smtpd/parse.y"
                     {
	filter_config->not_rdns_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->rdns_table = (yyvsp[0].v.table);
}
#line 3924 "../../usr.sbin/smtpd/parse.c"
    break;

  case 185: /* filter_phase_check_rdns_regex: negation RDNS REGEX tables  */
#line 1591 "../../usr.sbin/smtpd/parse.y"
                           {
	filter_config->not_rdns_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->rdns_regex = (yyvsp[0].v.table);
}
#line 3933 "../../usr.sbin/smtpd/parse.c"
    break;

  case 186: /* filter_phase_check_src_table: negation SRC tables  */
#line 1598 "../../usr.sbin/smtpd/parse.y"
                    {
	filter_config->not_src_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->src_table = (yyvsp[0].v.table);
}
#line 3942 "../../usr.sbin/smtpd/parse.c"
    break;

  case 187: /* filter_phase_check_src_regex: negation SRC REGEX tables  */
#line 1604 "../../usr.sbin/smtpd/parse.y"
                          {
	filter_config->not_src_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->src_regex = (yyvsp[0].v.table);
}
#line 3951 "../../usr.sbin/smtpd/parse.c"
    break;

  case 188: /* filter_phase_check_helo_table: negation HELO tables  */
#line 1611 "../../usr.sbin/smtpd/parse.y"
                     {
	filter_config->not_helo_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->helo_table = (yyvsp[0].v.table);
}
#line 3960 "../../usr.sbin/smtpd/parse.c"
    break;

  case 189: /* filter_phase_check_helo_regex: negation HELO REGEX tables  */
#line 1617 "../../usr.sbin/smtpd/parse.y"
                           {
	filter_config->not_helo_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->helo_regex = (yyvsp[0].v.table);
}
#line 3969 "../../usr.sbin/smtpd/parse.c"
    break;

  case 190: /* filter_phase_check_auth: negation AUTH  */
#line 1624 "../../usr.sbin/smtpd/parse.y"
              {
	filter_config->not_auth = (yyvsp[-1].v.number) ? -1 : 1;
	filter_config->auth = 1;
}
#line 3978 "../../usr.sbin/smtpd/parse.c"
    break;

  case 191: /* filter_phase_check_auth_table: negation AUTH tables  */
#line 1630 "../../usr.sbin/smtpd/parse.y"
                     {
	filter_config->not_auth_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->auth_table = (yyvsp[0].v.table);
}
#line 3987 "../../usr.sbin/smtpd/parse.c"
    break;

  case 192: /* filter_phase_check_auth_regex: negation AUTH REGEX tables  */
#line 1636 "../../usr.sbin/smtpd/parse.y"
                           {
	filter_config->not_auth_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->auth_regex = (yyvsp[0].v.table);
}
#line 3996 "../../usr.sbin/smtpd/parse.c"
    break;

  case 193: /* filter_phase_check_mail_from_table: negation MAIL_FROM tables  */
#line 1643 "../../usr.sbin/smtpd/parse.y"
                          {
	filter_config->not_mail_from_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->mail_from_table = (yyvsp[0].v.table);
}
#line 4005 "../../usr.sbin/smtpd/parse.c"
    break;

  case 194: /* filter_phase_check_mail_from_regex: negation MAIL_FROM REGEX tables  */
#line 1649 "../../usr.sbin/smtpd/parse.y"
                                {
	filter_config->not_mail_from_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->mail_from_regex = (yyvsp[0].v.table);
}
#line 4014 "../../usr.sbin/smtpd/parse.c"
    break;

  case 195: /* filter_phase_check_rcpt_to_table: negation RCPT_TO tables  */
#line 1656 "../../usr.sbin/smtpd/parse.y"
                        {
	filter_config->not_rcpt_to_table = (yyvsp[-2].v.number) ? -1 : 1;
	filter_config->rcpt_to_table = (yyvsp[0].v.table);
}
#line 4023 "../../usr.sbin/smtpd/parse.c"
    break;

  case 196: /* filter_phase_check_rcpt_to_regex: negation RCPT_TO REGEX tables  */
#line 1662 "../../usr.sbin/smtpd/parse.y"
                              {
	filter_config->not_rcpt_to_regex = (yyvsp[-3].v.number) ? -1 : 1;
	filter_config->rcpt_to_regex = (yyvsp[0].v.table);
}
#line 4032 "../../usr.sbin/smtpd/parse.c"
    break;

  case 247: /* $@20: %empty  */
#line 1753 "../../usr.sbin/smtpd/parse.y"
        {
	filter_config->phase = FILTER_CONNECT;
}
#line 4040 "../../usr.sbin/smtpd/parse.c"
    break;

  case 249: /* $@21: %empty  */
#line 1760 "../../usr.sbin/smtpd/parse.y"
     {
	filter_config->phase = FILTER_HELO;
}
#line 4048 "../../usr.sbin/smtpd/parse.c"
    break;

  case 251: /* $@22: %empty  */
#line 1766 "../../usr.sbin/smtpd/parse.y"
     {
	filter_config->phase = FILTER_EHLO;
}
#line 4056 "../../usr.sbin/smtpd/parse.c"
    break;

  case 253: /* $@23: %empty  */
#line 1772 "../../usr.sbin/smtpd/parse.y"
     {
}
#line 4063 "../../usr.sbin/smtpd/parse.c"
    break;

  case 255: /* $@24: %empty  */
#line 1777 "../../usr.sbin/smtpd/parse.y"
          {
	filter_config->phase = FILTER_MAIL_FROM;
}
#line 4071 "../../usr.sbin/smtpd/parse.c"
    break;

  case 257: /* $@25: %empty  */
#line 1783 "../../usr.sbin/smtpd/parse.y"
        {
	filter_config->phase = FILTER_RCPT_TO;
}
#line 4079 "../../usr.sbin/smtpd/parse.c"
    break;

  case 259: /* $@26: %empty  */
#line 1789 "../../usr.sbin/smtpd/parse.y"
     {
	filter_config->phase = FILTER_DATA;
}
#line 4087 "../../usr.sbin/smtpd/parse.c"
    break;

  case 261: /* $@27: %empty  */
#line 1821 "../../usr.sbin/smtpd/parse.y"
       {
	filter_config->phase = FILTER_COMMIT;
}
#line 4095 "../../usr.sbin/smtpd/parse.c"
    break;

  case 271: /* filterel: STRING  */
#line 1845 "../../usr.sbin/smtpd/parse.y"
        {
	struct filter_config   *fr;
	struct filter_proc     *fp;
	size_t			i;

	if ((fr = dict_get(conf->sc_filters_dict, (yyvsp[0].v.string))) == NULL) {
		yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if (fr->filter_type == FILTER_TYPE_CHAIN) {
		yyerror("no filter chain allowed within a filter chain: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	for (i = 0; i < filter_config->chain_size; i++) {
		if (strcmp(filter_config->chain[i], (yyvsp[0].v.string)) == 0) {
			yyerror("no filter allowed twice within a filter chain: %s", (yyvsp[0].v.string));
			free((yyvsp[0].v.string));
			YYERROR;
		}
	}

	if (fr->proc) {
		if ((fp = dict_get(&filter_config->chain_procs, fr->proc))) {
			yyerror("no proc allowed twice within a filter chain: %s", fr->proc);
			free((yyvsp[0].v.string));
			YYERROR;
		}
		dict_set(&filter_config->chain_procs, fr->proc, NULL);
	}

	fr->filter_subsystem |= filter_config->filter_subsystem;
	filter_config->chain_size += 1;
	filter_config->chain = reallocarray(filter_config->chain, filter_config->chain_size, sizeof(char *));
	if (filter_config->chain == NULL)
		err(1, NULL);
	filter_config->chain[filter_config->chain_size - 1] = (yyvsp[0].v.string);
}
#line 4140 "../../usr.sbin/smtpd/parse.c"
    break;

  case 274: /* filter: FILTER STRING PROC STRING  */
#line 1893 "../../usr.sbin/smtpd/parse.y"
                          {
	struct filter_proc *fp;

	if (dict_get(conf->sc_filters_dict, (yyvsp[-2].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-2].v.string));
		free((yyvsp[-2].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}
	if ((fp = dict_get(conf->sc_filter_processes_dict, (yyvsp[0].v.string))) == NULL) {
		yyerror("no processor exist with that name: %s", (yyvsp[0].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_PROC;
	filter_config->name = (yyvsp[-2].v.string);
	filter_config->proc = (yyvsp[0].v.string);
	dict_set(conf->sc_filters_dict, (yyvsp[-2].v.string), filter_config);
	filter_config = NULL;
}
#line 4167 "../../usr.sbin/smtpd/parse.c"
    break;

  case 275: /* $@28: %empty  */
#line 1916 "../../usr.sbin/smtpd/parse.y"
                               {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-2].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-2].v.string));
		free((yyvsp[-2].v.string));
		free((yyvsp[0].v.string));
		YYERROR;
	}

	processor = xcalloc(1, sizeof *processor);
	processor->command = (yyvsp[0].v.string);

	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_PROC;
	filter_config->name = (yyvsp[-2].v.string);
	filter_config->proc = xstrdup((yyvsp[-2].v.string));
	dict_set(conf->sc_filters_dict, (yyvsp[-2].v.string), filter_config);
}
#line 4189 "../../usr.sbin/smtpd/parse.c"
    break;

  case 276: /* filter: FILTER STRING PROC_EXEC STRING $@28 proc_params  */
#line 1932 "../../usr.sbin/smtpd/parse.y"
              {
	dict_set(conf->sc_filter_processes_dict, filter_config->proc, processor);
	processor = NULL;
	filter_config = NULL;
}
#line 4199 "../../usr.sbin/smtpd/parse.c"
    break;

  case 277: /* $@29: %empty  */
#line 1938 "../../usr.sbin/smtpd/parse.y"
                    {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-1].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-1].v.string));
		free((yyvsp[-1].v.string));
		YYERROR;
	}
	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->name = (yyvsp[-1].v.string);
	filter_config->filter_type = FILTER_TYPE_BUILTIN;
	dict_set(conf->sc_filters_dict, (yyvsp[-1].v.string), filter_config);
}
#line 4215 "../../usr.sbin/smtpd/parse.c"
    break;

  case 278: /* filter: FILTER STRING PHASE $@29 filter_phase  */
#line 1948 "../../usr.sbin/smtpd/parse.y"
               {
	filter_config = NULL;
}
#line 4223 "../../usr.sbin/smtpd/parse.c"
    break;

  case 279: /* $@30: %empty  */
#line 1952 "../../usr.sbin/smtpd/parse.y"
                    {
	if (dict_get(conf->sc_filters_dict, (yyvsp[-1].v.string))) {
		yyerror("filter already exists with that name: %s", (yyvsp[-1].v.string));
		free((yyvsp[-1].v.string));
		YYERROR;
	}
	filter_config = xcalloc(1, sizeof *filter_config);
	filter_config->filter_type = FILTER_TYPE_CHAIN;
	dict_init(&filter_config->chain_procs);
}
#line 4238 "../../usr.sbin/smtpd/parse.c"
    break;

  case 280: /* filter: FILTER STRING CHAIN $@30 '{' filter_list '}'  */
#line 1961 "../../usr.sbin/smtpd/parse.y"
                      {
	dict_set(conf->sc_filters_dict, (yyvsp[-5].v.string), filter_config);
	filter_config = NULL;
}
#line 4247 "../../usr.sbin/smtpd/parse.c"
    break;

  case 281: /* size: NUMBER  */
#line 1967 "../../usr.sbin/smtpd/parse.y"
                                        {
			if ((yyvsp[0].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[0].v.number);
		}
#line 4259 "../../usr.sbin/smtpd/parse.c"
    break;

  case 282: /* size: STRING  */
#line 1974 "../../usr.sbin/smtpd/parse.y"
                                                {
			long long result;

			if (scan_scaled((yyvsp[0].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			(yyval.v.number) = result;
		}
#line 4275 "../../usr.sbin/smtpd/parse.c"
    break;

  case 283: /* bouncedelay: STRING  */
#line 1987 "../../usr.sbin/smtpd/parse.y"
                         {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[0].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
#line 4298 "../../usr.sbin/smtpd/parse.c"
    break;

  case 286: /* opt_limit_mda: STRING NUMBER  */
#line 2011 "../../usr.sbin/smtpd/parse.y"
                                {
			if (!strcmp((yyvsp[-1].v.string), "max-session")) {
				conf->sc_mda_max_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-session-per-user")) {
				conf->sc_mda_max_user_session = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-lowat")) {
				conf->sc_mda_task_lowat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-hiwat")) {
				conf->sc_mda_task_hiwat = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "task-release")) {
				conf->sc_mda_task_release = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 4326 "../../usr.sbin/smtpd/parse.c"
    break;

  case 289: /* opt_limit_smtp: STRING NUMBER  */
#line 2040 "../../usr.sbin/smtpd/parse.y"
                               {
			if (!strcmp((yyvsp[-1].v.string), "max-rcpt")) {
				conf->sc_session_max_rcpt = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-mails")) {
				conf->sc_session_max_mails = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid session limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 4345 "../../usr.sbin/smtpd/parse.c"
    break;

  case 292: /* opt_limit_mta: INET4  */
#line 2060 "../../usr.sbin/smtpd/parse.y"
                        {
			limits->family = AF_INET;
		}
#line 4353 "../../usr.sbin/smtpd/parse.c"
    break;

  case 293: /* opt_limit_mta: INET6  */
#line 2063 "../../usr.sbin/smtpd/parse.y"
                        {
			limits->family = AF_INET6;
		}
#line 4361 "../../usr.sbin/smtpd/parse.c"
    break;

  case 294: /* opt_limit_mta: STRING NUMBER  */
#line 2066 "../../usr.sbin/smtpd/parse.y"
                                {
			if (!limit_mta_set(limits, (yyvsp[-1].v.string), (yyvsp[0].v.number))) {
				yyerror("invalid mta limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 4374 "../../usr.sbin/smtpd/parse.c"
    break;

  case 297: /* opt_limit_scheduler: STRING NUMBER  */
#line 2080 "../../usr.sbin/smtpd/parse.y"
                                    {
			if (!strcmp((yyvsp[-1].v.string), "max-inflight")) {
				conf->sc_scheduler_max_inflight = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-evp-batch-size")) {
				conf->sc_scheduler_max_evp_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-msg-batch-size")) {
				conf->sc_scheduler_max_msg_batch_size = (yyvsp[0].v.number);
			}
			else if (!strcmp((yyvsp[-1].v.string), "max-schedule")) {
				conf->sc_scheduler_max_schedule = (yyvsp[0].v.number);
			}
			else {
				yyerror("invalid scheduler limit keyword: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
		}
#line 4399 "../../usr.sbin/smtpd/parse.c"
    break;

  case 300: /* opt_sock_listen: FILTER STRING  */
#line 2107 "../../usr.sbin/smtpd/parse.y"
                                {
			struct filter_config *fc;

			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			if ((fc = dict_get(conf->sc_filters_dict, (yyvsp[0].v.string))) == NULL) {
				yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			fc->filter_subsystem |= FILTER_SUBSYSTEM_SMTP_IN;
			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = (yyvsp[0].v.string);
		}
#line 4421 "../../usr.sbin/smtpd/parse.c"
    break;

  case 301: /* $@31: %empty  */
#line 2124 "../../usr.sbin/smtpd/parse.y"
                         {
			char	buffer[128];

			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;
			}

			do {
				(void)snprintf(buffer, sizeof buffer, "<dynchain:%08x>", last_dynchain_id++);
			} while (dict_check(conf->sc_filters_dict, buffer));

			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = xstrdup(buffer);
			filter_config = xcalloc(1, sizeof *filter_config);
			filter_config->filter_type = FILTER_TYPE_CHAIN;
			filter_config->filter_subsystem |= FILTER_SUBSYSTEM_SMTP_IN;
			dict_init(&filter_config->chain_procs);
		}
#line 4445 "../../usr.sbin/smtpd/parse.c"
    break;

  case 302: /* opt_sock_listen: FILTER $@31 '{' filter_list '}'  */
#line 2142 "../../usr.sbin/smtpd/parse.y"
                                      {
			dict_set(conf->sc_filters_dict, listen_opts.filtername, filter_config);
			filter_config = NULL;
		}
#line 4454 "../../usr.sbin/smtpd/parse.c"
    break;

  case 303: /* opt_sock_listen: MASK_SRC  */
#line 2146 "../../usr.sbin/smtpd/parse.y"
                           {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
#line 4464 "../../usr.sbin/smtpd/parse.c"
    break;

  case 304: /* opt_sock_listen: TAG STRING  */
#line 2151 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;
			}
			listen_opts.options |= LO_TAG;

			if (strlen((yyvsp[0].v.string)) >= SMTPD_TAG_SIZE) {
				yyerror("tag name too long");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[0].v.string);
		}
#line 4483 "../../usr.sbin/smtpd/parse.c"
    break;

  case 305: /* opt_if_listen: INET4  */
#line 2167 "../../usr.sbin/smtpd/parse.y"
                      {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET;
		}
#line 4496 "../../usr.sbin/smtpd/parse.c"
    break;

  case 306: /* opt_if_listen: INET6  */
#line 2175 "../../usr.sbin/smtpd/parse.y"
                                        {
			if (listen_opts.options & LO_FAMILY) {
				yyerror("address family already specified");
				YYERROR;
			}
			listen_opts.options |= LO_FAMILY;
			listen_opts.family = AF_INET6;
		}
#line 4509 "../../usr.sbin/smtpd/parse.c"
    break;

  case 307: /* opt_if_listen: PORT STRING  */
#line 2183 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct servent	*servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname((yyvsp[0].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			free((yyvsp[0].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
#line 4532 "../../usr.sbin/smtpd/parse.c"
    break;

  case 308: /* opt_if_listen: PORT SMTP  */
#line 2201 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct servent *servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname("smtp", "tcp");
			if (servent == NULL) {
				yyerror("invalid port: smtp");
				YYERROR;
			}
			listen_opts.port = ntohs(servent->s_port);
		}
#line 4553 "../../usr.sbin/smtpd/parse.c"
    break;

  case 309: /* opt_if_listen: PORT SMTPS  */
#line 2217 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct servent *servent;

			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			servent = getservbyname("smtps", "tcp");
			if (servent == NULL) {
				yyerror("invalid port: smtps");
				YYERROR;
			}
			listen_opts.port = ntohs(servent->s_port);
		}
#line 4574 "../../usr.sbin/smtpd/parse.c"
    break;

  case 310: /* opt_if_listen: PORT NUMBER  */
#line 2233 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_PORT) {
				yyerror("port already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PORT;

			if ((yyvsp[0].v.number) <= 0 || (yyvsp[0].v.number) > (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[0].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[0].v.number);
		}
#line 4592 "../../usr.sbin/smtpd/parse.c"
    break;

  case 311: /* opt_if_listen: FILTER STRING  */
#line 2246 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct filter_config *fc;

			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;
			}
			if ((fc = dict_get(conf->sc_filters_dict, (yyvsp[0].v.string))) == NULL) {
				yyerror("no filter exist with that name: %s", (yyvsp[0].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			fc->filter_subsystem |= FILTER_SUBSYSTEM_SMTP_IN;
			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = (yyvsp[0].v.string);
		}
#line 4613 "../../usr.sbin/smtpd/parse.c"
    break;

  case 312: /* $@32: %empty  */
#line 2262 "../../usr.sbin/smtpd/parse.y"
                         {
			char	buffer[128];

			if (listen_opts.options & LO_FILTER) {
				yyerror("filter already specified");
				YYERROR;
			}

			do {
				(void)snprintf(buffer, sizeof buffer, "<dynchain:%08x>", last_dynchain_id++);
			} while (dict_check(conf->sc_filters_dict, buffer));

			listen_opts.options |= LO_FILTER;
			listen_opts.filtername = xstrdup(buffer);
			filter_config = xcalloc(1, sizeof *filter_config);
			filter_config->filter_type = FILTER_TYPE_CHAIN;
			filter_config->filter_subsystem |= FILTER_SUBSYSTEM_SMTP_IN;
			dict_init(&filter_config->chain_procs);
		}
#line 4637 "../../usr.sbin/smtpd/parse.c"
    break;

  case 313: /* opt_if_listen: FILTER $@32 '{' filter_list '}'  */
#line 2280 "../../usr.sbin/smtpd/parse.y"
                                      {
			dict_set(conf->sc_filters_dict, listen_opts.filtername, filter_config);
			filter_config = NULL;
		}
#line 4646 "../../usr.sbin/smtpd/parse.c"
    break;

  case 314: /* opt_if_listen: SMTPS  */
#line 2284 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS;
		}
#line 4659 "../../usr.sbin/smtpd/parse.c"
    break;

  case 315: /* opt_if_listen: SMTPS VERIFY  */
#line 2292 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_SMTPS|F_TLS_VERIFY;
		}
#line 4672 "../../usr.sbin/smtpd/parse.c"
    break;

  case 316: /* opt_if_listen: TLS  */
#line 2300 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS;
		}
#line 4685 "../../usr.sbin/smtpd/parse.c"
    break;

  case 317: /* opt_if_listen: TLS_REQUIRE  */
#line 2308 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE;
		}
#line 4698 "../../usr.sbin/smtpd/parse.c"
    break;

  case 318: /* opt_if_listen: TLS_REQUIRE VERIFY  */
#line 2316 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_SSL) {
				yyerror("TLS mode already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SSL;
			listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY;
		}
#line 4711 "../../usr.sbin/smtpd/parse.c"
    break;

  case 319: /* opt_if_listen: PKI STRING  */
#line 2324 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_PKI) {
				yyerror("pki already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PKI;
			listen_opts.pki = (yyvsp[0].v.string);
		}
#line 4724 "../../usr.sbin/smtpd/parse.c"
    break;

  case 320: /* opt_if_listen: CA STRING  */
#line 2332 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_CA) {
				yyerror("ca already specified");
				YYERROR;
			}
			listen_opts.options |= LO_CA;
			listen_opts.ca = (yyvsp[0].v.string);
		}
#line 4737 "../../usr.sbin/smtpd/parse.c"
    break;

  case 321: /* opt_if_listen: AUTH  */
#line 2340 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 4750 "../../usr.sbin/smtpd/parse.c"
    break;

  case 322: /* opt_if_listen: AUTH_OPTIONAL  */
#line 2348 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.auth = F_AUTH;
		}
#line 4763 "../../usr.sbin/smtpd/parse.c"
    break;

  case 323: /* opt_if_listen: AUTH tables  */
#line 2356 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
#line 4777 "../../usr.sbin/smtpd/parse.c"
    break;

  case 324: /* opt_if_listen: AUTH_OPTIONAL tables  */
#line 2365 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_AUTH) {
				yyerror("auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_AUTH;
			listen_opts.authtable = (yyvsp[0].v.table);
			listen_opts.auth = F_AUTH;
		}
#line 4791 "../../usr.sbin/smtpd/parse.c"
    break;

  case 325: /* opt_if_listen: TAG STRING  */
#line 2374 "../../usr.sbin/smtpd/parse.y"
                                                {
			if (listen_opts.options & LO_TAG) {
				yyerror("tag already specified");
				YYERROR;
			}
			listen_opts.options |= LO_TAG;

			if (strlen((yyvsp[0].v.string)) >= SMTPD_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[0].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[0].v.string);
		}
#line 4810 "../../usr.sbin/smtpd/parse.c"
    break;

  case 326: /* opt_if_listen: HOSTNAME STRING  */
#line 2388 "../../usr.sbin/smtpd/parse.y"
                                        {
			if (listen_opts.options & LO_HOSTNAME) {
				yyerror("hostname already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAME;

			listen_opts.hostname = (yyvsp[0].v.string);
		}
#line 4824 "../../usr.sbin/smtpd/parse.c"
    break;

  case 327: /* opt_if_listen: HOSTNAMES tables  */
#line 2397 "../../usr.sbin/smtpd/parse.y"
                                        {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_HOSTNAMES) {
				yyerror("hostnames already specified");
				YYERROR;
			}
			listen_opts.options |= LO_HOSTNAMES;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
#line 4845 "../../usr.sbin/smtpd/parse.c"
    break;

  case 328: /* opt_if_listen: MASK_SRC  */
#line 2413 "../../usr.sbin/smtpd/parse.y"
                                {
			if (config_lo_mask_source(&listen_opts)) {
				YYERROR;
			}
		}
#line 4855 "../../usr.sbin/smtpd/parse.c"
    break;

  case 329: /* opt_if_listen: RECEIVEDAUTH  */
#line 2418 "../../usr.sbin/smtpd/parse.y"
                                {
			if (listen_opts.options & LO_RECEIVEDAUTH) {
				yyerror("received-auth already specified");
				YYERROR;
			}
			listen_opts.options |= LO_RECEIVEDAUTH;
			listen_opts.flags |= F_RECEIVEDAUTH;
		}
#line 4868 "../../usr.sbin/smtpd/parse.c"
    break;

  case 330: /* opt_if_listen: NO_DSN  */
#line 2426 "../../usr.sbin/smtpd/parse.y"
                                {
			if (listen_opts.options & LO_NODSN) {
				yyerror("no-dsn already specified");
				YYERROR;
			}
			listen_opts.options |= LO_NODSN;
			listen_opts.flags &= ~F_EXT_DSN;
		}
#line 4881 "../../usr.sbin/smtpd/parse.c"
    break;

  case 331: /* opt_if_listen: PROXY_V2  */
#line 2434 "../../usr.sbin/smtpd/parse.y"
                                {
			if (listen_opts.options & LO_PROXY) {
				yyerror("proxy-v2 already specified");
				YYERROR;
			}
			listen_opts.options |= LO_PROXY;
			listen_opts.flags |= F_PROXY;
		}
#line 4894 "../../usr.sbin/smtpd/parse.c"
    break;

  case 332: /* opt_if_listen: SENDERS tables  */
#line 2442 "../../usr.sbin/smtpd/parse.y"
                                        {
			struct table	*t = (yyvsp[0].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 4915 "../../usr.sbin/smtpd/parse.c"
    break;

  case 333: /* opt_if_listen: SENDERS tables MASQUERADE  */
#line 2458 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct table	*t = (yyvsp[-1].v.table);

			if (listen_opts.options & LO_SENDERS) {
				yyerror("senders already specified");
				YYERROR;
			}
			listen_opts.options |= LO_SENDERS|LO_MASQUERADE;

			if (!table_check_use(t, T_DYNAMIC|T_HASH, K_MAILADDRMAP)) {
				yyerror("invalid use of table \"%s\" as "
				    "SENDERS parameter", t->t_name);
				YYERROR;
			}
			listen_opts.sendertable = t;
		}
#line 4936 "../../usr.sbin/smtpd/parse.c"
    break;

  case 336: /* socket_listener: SOCKET sock_listen  */
#line 2480 "../../usr.sbin/smtpd/parse.y"
                                     {
			if (conf->sc_sock_listener) {
				yyerror("socket listener already configured");
				YYERROR;
			}
			create_sock_listener(&listen_opts);
		}
#line 4948 "../../usr.sbin/smtpd/parse.c"
    break;

  case 337: /* if_listener: STRING if_listen  */
#line 2489 "../../usr.sbin/smtpd/parse.y"
                                   {
			listen_opts.ifx = (yyvsp[-1].v.string);
			create_if_listener(&listen_opts);
		}
#line 4957 "../../usr.sbin/smtpd/parse.c"
    break;

  case 342: /* $@33: %empty  */
#line 2504 "../../usr.sbin/smtpd/parse.y"
                         {
			memset(&listen_opts, 0, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
			listen_opts.flags |= F_EXT_DSN;
		}
#line 4967 "../../usr.sbin/smtpd/parse.c"
    break;

  case 344: /* table: TABLE STRING STRING  */
#line 2511 "../../usr.sbin/smtpd/parse.y"
                                        {
			char *p, *backend, *config;

			p = (yyvsp[0].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[0].v.string);
			}
			else {
				backend = (yyvsp[0].v.string);
				config = NULL;
				for (p = (yyvsp[0].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[0].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = table_create(conf, backend, (yyvsp[-1].v.string), config);
			if (!table_config(table)) {
				yyerror("invalid configuration file %s for table %s",
				    config, table->t_name);
				free((yyvsp[-1].v.string));
				free((yyvsp[0].v.string));
				YYERROR;
			}
			table = NULL;
			free((yyvsp[-1].v.string));
			free((yyvsp[0].v.string));
		}
#line 5010 "../../usr.sbin/smtpd/parse.c"
    break;

  case 345: /* $@34: %empty  */
#line 2549 "../../usr.sbin/smtpd/parse.y"
                               {
			table = table_create(conf, "static", (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
		}
#line 5019 "../../usr.sbin/smtpd/parse.c"
    break;

  case 346: /* table: TABLE STRING $@34 '{' tableval_list '}'  */
#line 2552 "../../usr.sbin/smtpd/parse.y"
                                        {
			table = NULL;
		}
#line 5027 "../../usr.sbin/smtpd/parse.c"
    break;

  case 347: /* tablenew: STRING  */
#line 2557 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct table	*t;

			t = table_create(conf, "static", NULL, NULL);
			table_add(t, (yyvsp[0].v.string), NULL);
			free((yyvsp[0].v.string));
			(yyval.v.table) = t;
		}
#line 5040 "../../usr.sbin/smtpd/parse.c"
    break;

  case 348: /* $@35: %empty  */
#line 2565 "../../usr.sbin/smtpd/parse.y"
                                                {
			table = table_create(conf, "static", NULL, NULL);
		}
#line 5048 "../../usr.sbin/smtpd/parse.c"
    break;

  case 349: /* tablenew: '{' $@35 tableval_list '}'  */
#line 2567 "../../usr.sbin/smtpd/parse.y"
                                                {
			(yyval.v.table) = table;
			table = NULL;
		}
#line 5057 "../../usr.sbin/smtpd/parse.c"
    break;

  case 350: /* tableref: '<' STRING '>'  */
#line 2573 "../../usr.sbin/smtpd/parse.y"
                                                {
			struct table	*t;

			if ((t = table_find(conf, (yyvsp[-1].v.string))) == NULL) {
				yyerror("no such table: %s", (yyvsp[-1].v.string));
				free((yyvsp[-1].v.string));
				YYERROR;
			}
			free((yyvsp[-1].v.string));
			(yyval.v.table) = t;
		}
#line 5073 "../../usr.sbin/smtpd/parse.c"
    break;

  case 351: /* tables: tablenew  */
#line 2586 "../../usr.sbin/smtpd/parse.y"
                                                { (yyval.v.table) = (yyvsp[0].v.table); }
#line 5079 "../../usr.sbin/smtpd/parse.c"
    break;

  case 352: /* tables: tableref  */
#line 2587 "../../usr.sbin/smtpd/parse.y"
                                                { (yyval.v.table) = (yyvsp[0].v.table); }
#line 5085 "../../usr.sbin/smtpd/parse.c"
    break;


#line 5089 "../../usr.sbin/smtpd/parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2591 "../../usr.sbin/smtpd/parse.y"


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*msg;

	file->errors++;
	va_start(ap, fmt);
	if (vasprintf(&msg, fmt, ap) == -1)
		fatalx("yyerror vasprintf");
	va_end(ap);
	logit(LOG_CRIT, "%s:%d: %s", file->name, yylval.lineno, msg);
	free(msg);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "action",		ACTION },
		{ "admd",		ADMD },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce",		BOUNCE },
		{ "bypass",		BYPASS },
		{ "ca",			CA },
		{ "cert",		CERT },
		{ "chain",		CHAIN },
		{ "chroot",		CHROOT },
		{ "ciphers",		CIPHERS },
		{ "commit",		COMMIT },
		{ "compression",	COMPRESSION },
		{ "connect",		CONNECT },
		{ "data",		DATA },
		{ "data-line",		DATA_LINE },
		{ "dhe",		DHE },
		{ "disconnect",		DISCONNECT },
		{ "domain",		DOMAIN },
		{ "ehlo",		EHLO },
		{ "encryption",		ENCRYPTION },
		{ "expand-only",      	EXPAND_ONLY },
		{ "fcrdns",		FCRDNS },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARD_ONLY },
		{ "from",		FROM },
		{ "group",		GROUP },
		{ "helo",		HELO },
		{ "helo-src",       	HELO_SRC },
		{ "host",		HOST },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "junk",		JUNK },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "mail-from",		MAIL_FROM },
		{ "maildir",		MAILDIR },
		{ "mask-src",		MASK_SRC },
		{ "masquerade",		MASQUERADE },
		{ "match",		MATCH },
		{ "max-deferred",  	MAX_DEFERRED },
		{ "max-message-size",  	MAX_MESSAGE_SIZE },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "mx",			MX },
		{ "no-dsn",		NO_DSN },
		{ "no-verify",		NO_VERIFY },
		{ "noop",		NOOP },
		{ "on",			ON },
		{ "phase",		PHASE },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "proc",		PROC },
		{ "proc-exec",		PROC_EXEC },
		{ "proxy-v2",		PROXY_V2 },
		{ "queue",		QUEUE },
		{ "quit",		QUIT },
		{ "rcpt-to",		RCPT_TO },
		{ "rdns",		RDNS },
		{ "received-auth",     	RECEIVEDAUTH },
		{ "recipient",		RECIPIENT },
		{ "regex",		REGEX },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "report",		REPORT },
		{ "rewrite",		REWRITE },
		{ "rset",		RSET },
		{ "scheduler",		SCHEDULER },
		{ "senders",   		SENDERS },
		{ "smtp",		SMTP },
		{ "smtp-in",		SMTP_IN },
		{ "smtp-out",		SMTP_OUT },
		{ "smtps",		SMTPS },
		{ "socket",		SOCKET },
		{ "src",		SRC },
		{ "srs",		SRS },
		{ "sub-addr-delim",	SUB_ADDR_DELIM },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "ttl",		TTL },
		{ "user",		USER },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "virtual",		VIRTUAL },
		{ "warn-interval",	WARN_INTERVAL },
		{ "wrapper",		WRAPPER },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define START_EXPAND	1
#define DONE_EXPAND	2

static int	expanding;

int
igetc(void)
{
	int	c;

	while (1) {
		if (file->ungetpos > 0)
			c = file->ungetbuf[--file->ungetpos];
		else
			c = getc(file->stream);

		if (c == START_EXPAND)
			expanding = 1;
		else if (c == DONE_EXPAND)
			expanding = 0;
		else
			break;
	}
	return (c);
}

int
lgetc(int quotec)
{
	int		c, next;

	if (quotec) {
		if ((c = igetc()) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = igetc()) == '\\') {
		next = igetc();
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	if (c == EOF) {
		/*
		 * Fake EOL when hit EOF for the first time. This gets line
		 * count right if last line in included file is syntactically
		 * invalid and has no newline.
		 */
		if (file->eof_reached == 0) {
			file->eof_reached = 1;
			return ('\n');
		}
		while (c == EOF) {
			if (file == topfile || popfile() == EOF)
				return (EOF);
			c = igetc();
		}
	}
	return (c);
}

void
lungetc(int c)
{
	if (c == EOF)
		return;

	if (file->ungetpos >= file->ungetsize) {
		void *p = reallocarray(file->ungetbuf, file->ungetsize, 2);
		if (p == NULL)
			err(1, "%s", __func__);
		file->ungetbuf = p;
		file->ungetsize *= 2;
	}
	file->ungetbuf[file->ungetpos++] = c;
}

int
findeol(void)
{
	int	c;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	unsigned char	 buf[8096];
	unsigned char	*p, *val;
	int		 quotec, next, c;
	int		 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && !expanding) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		p = val + strlen(val) - 1;
		lungetc(DONE_EXPAND);
		while (p >= val) {
			lungetc(*p);
			p--;
		}
		lungetc(START_EXPAND);
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || next == ' ' ||
				    next == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "%s", __func__);
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((size_t)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((size_t)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "%s", __func__);
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("%s", __func__);
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("%s", __func__);
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("%s: %s", __func__, nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = TAILQ_EMPTY(&files) ? 1 : 0;
	nfile->ungetsize = 16;
	nfile->ungetbuf = malloc(nfile->ungetsize);
	if (nfile->ungetbuf == NULL) {
		log_warn("%s", __func__);
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file->ungetbuf);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;

	conf = x_conf;
	errors = 0;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* If the socket listener was not configured, create a default one. */
	if (!conf->sc_sock_listener) {
		memset(&listen_opts, 0, sizeof listen_opts);
		create_sock_listener(&listen_opts);
	}

	/* Free macros and check which have not been used. */
	TAILQ_FOREACH_SAFE(sym, &symhead, entry, next) {
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0)
			break;
	}

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);
	sym = strndup(s, val - s);
	if (sym == NULL)
		errx(1, "%s: strndup", __func__);
	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	}
	return (NULL);
}

static void
create_sock_listener(struct listen_opts *lo)
{
	struct listener *l = xcalloc(1, sizeof(*l));
	lo->hostname = conf->sc_hostname;
	l->ss.ss_family = AF_LOCAL;
#ifdef HAVE_STRUCT_SOCKADDR_STORAGE_SS_LEN
	l->ss.ss_len = sizeof(struct sockaddr *);
#endif
	l->local = 1;
	conf->sc_sock_listener = l;
	config_listener(l, lo);
}

static void
create_if_listener(struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");

	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");

	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");

	flags = lo->flags;

	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
		}

		if (!lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
		}
	}

	if (interface(lo))
		return;
	if (host_v4(lo))
		return;
	if (host_v6(lo))
		return;
	if (host_dns(lo))
		return;

	errx(1, "invalid virtual ip or interface: %s", lo->ifx);
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	if (lo->options & LO_FILTER) {
		h->flags |= F_FILTERED;
		(void)strlcpy(h->filter_name,
		    lo->filtername,
		    sizeof(h->filter_name));
	}

	h->pki_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable->t_name, sizeof(h->authtable));
	if (lo->pki != NULL) {
		if (!lowercase(h->pki_name, lo->pki, sizeof(h->pki_name))) {
			log_warnx("pki name too long: %s", lo->pki);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_pki_dict, h->pki_name) == NULL) {
			log_warnx("pki name not found: %s", lo->pki);
			fatalx(NULL);
		}
	}

	if (lo->ca != NULL) {
		if (!lowercase(h->ca_name, lo->ca, sizeof(h->ca_name))) {
			log_warnx("ca name too long: %s", lo->ca);
			fatalx(NULL);
		}
		if (dict_get(conf->sc_ca_dict, h->ca_name) == NULL) {
			log_warnx("ca name not found: %s", lo->ca);
			fatalx(NULL);
		}
	}
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
	if (lo->sendertable) {
		(void)strlcpy(h->sendertable, lo->sendertable->t_name, sizeof(h->sendertable));
		if (lo->options & LO_MASQUERADE)
			h->flags |= F_MASQUERADE;
	}

	if (lo->ssl & F_TLS_VERIFY)
		h->flags |= F_TLS_VERIFY;

	if (lo->ssl & F_STARTTLS_REQUIRE)
		h->flags |= F_STARTTLS_REQUIRE;
	
	if (h != conf->sc_sock_listener)
		TAILQ_INSERT_TAIL(conf->sc_listeners, h, entry);
}

static int
host_v4(struct listen_opts *lo)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET)
		return (0);

	memset(&ina, 0, sizeof(ina));
	if (inet_pton(AF_INET, lo->ifx, &ina) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = lo->port;

	if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_v6(struct listen_opts *lo)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	if (lo->family != AF_UNSPEC && lo->family != AF_INET6)
		return (0);

	memset(&ina6, 0, sizeof(ina6));
	if (inet_pton(AF_INET6, lo->ifx, &ina6) != 1)
		return (0);

	h = xcalloc(1, sizeof(*h));
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = lo->port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
		h->local = 1;
	config_listener(h,  lo);

	return (1);
}

static int
host_dns(struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = lo->family;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h));

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
		}

		config_listener(h, lo);

		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

static int
interface(struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    !is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h));

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			if (sain->sin_addr.s_addr == htonl(INADDR_LOOPBACK))
				h->local = 1;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			if (IN6_IS_ADDR_LOOPBACK(&sin6->sin6_addr))
				h->local = 1;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
	}

	freeifaddrs(ifap);

	return ret;
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;

	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;

	switch(str[len - 1]) {

	case 's':
		factor = 1;
		break;

	case 'm':
		factor = 60;
		break;

	case 'h':
		factor = 60 * 60;
		break;

	case 'd':
		factor = 24 * 60 * 60;
		break;

	default:
		goto bad;
	}

	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;

	return (delay * factor);

bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        if (strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ) >= IFNAMSIZ)
		errx(1, "interface name too large");

        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups = xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req));
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");

        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

static int
config_lo_mask_source(struct listen_opts *lo) {
	if (lo->options & LO_MASKSOURCE) {
		yyerror("mask-source already specified");
		return -1;
	}
	lo->options |= LO_MASKSOURCE;
	lo->flags |= F_MASK_SOURCE;

	return 0;
}

